SystemOrganization addCategory: 'Seaside-Tests-Core'!

WARequestHandler subclass: #WANextUnconsumedPathElementRequestHandler
	instanceVariableNames: 'nextUnconsumedPathElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WANextUnconsumedPathElementRequestHandler methodsFor: 'accessing' stamp: 'pmm 9/5/2009 12:16'!
handle: aRequestContext
	| consumer |
	consumer := aRequestContext consumer.
	nextUnconsumedPathElement := consumer atEnd
		ifTrue: [ nil ]
		ifFalse: [ aRequestContext consumer peek ].
	super handle: aRequestContext! !

!WANextUnconsumedPathElementRequestHandler methodsFor: 'accessing' stamp: 'jf 9/1/2009 00:53'!
handleFiltered: aRequestContext! !

!WANextUnconsumedPathElementRequestHandler methodsFor: 'accessing' stamp: 'pmm 8/31/2009 11:02'!
nextUnconsumedPathElement
	^nextUnconsumedPathElement! !

WARequestHandler subclass: #WATestNoopRequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WATestNoopRequestHandler methodsFor: 'handling' stamp: 'jf 1/30/2009 15:59'!
handleFiltered: aRequestContext
	"do nothing"! !

TestCase subclass: #WAAcceptTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAAcceptTest methodsFor: 'private' stamp: 'pmm 9/10/2008 22:55'!
assert: anArray at: anInteger charset: aString quality: aFloat
	| value |
	value := (anArray at: anInteger).
	self assert: (value isKindOf: WAQualifiedValue).
	self assert: value quality = aFloat.
	
	self assert: value value = aString! !

!WAAcceptTest methodsFor: 'private' stamp: 'pmm 9/10/2008 22:56'!
assert: anArray at: anInteger encoding: aString quality: aFloat
	self assert: anArray at: anInteger charset: aString quality: aFloat! !

!WAAcceptTest methodsFor: 'private' stamp: 'pmm 11/21/2007 22:17'!
assert: anArray at: anInteger language: aLanguageString country: aCountryString quality: aFloat
	| value mimeType |
	value := (anArray at: anInteger).
	self assert: (value isKindOf: WAQualifiedValue).
	self assert: value quality = aFloat.
	
	mimeType := value value.
	self assert: (mimeType isKindOf: WALocale).
	self assert: (mimeType language = aLanguageString).
	self assert: (mimeType country = aCountryString).! !

!WAAcceptTest methodsFor: 'private' stamp: 'pmm 11/21/2007 22:04'!
assert: anArray at: anInteger main: aMainString sub: aSubString quality: aFloat
	| value mimeType |
	value := (anArray at: anInteger).
	self assert: (value isKindOf: WAQualifiedValue).
	self assert: value quality = aFloat.
	
	mimeType := value value.
	self assert: (mimeType isKindOf: WAMimeType).
	self assert: (mimeType main = aMainString).
	self assert: (mimeType sub = aSubString).! !

!WAAcceptTest methodsFor: 'testing' stamp: 'pmm 8/28/2009 08:36'!
testIe6
	| accept acceptLanguage acceptEncoding |
	accept := WAAccept fromString: 'image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/vnd.ms-excel, application/msword, application/vnd.ms-powerpoint, application/x-shockwave-flash, */*'.
	self assert: accept size = 9.
	self assert: accept at: 1 main: 'image' sub: 'gif' quality: 1.0.
	self assert: accept at: 2 main: 'image' sub: 'x-xbitmap' quality: 1.0.
	self assert: accept at: 3 main: 'image' sub: 'jpeg' quality: 1.0.
	self assert: accept at: 4 main: 'image' sub: 'pjpeg' quality: 1.0.
	self assert: accept at: 5 main: 'application' sub: 'vnd.ms-excel' quality: 1.0.
	self assert: accept at: 6 main: 'application' sub: 'msword' quality: 1.0.
	self assert: accept at: 7 main: 'application' sub: 'vnd.ms-powerpoint' quality: 1.0.
	self assert: accept at: 8 main: 'application' sub: 'x-shockwave-flash' quality: 1.0.
	self assert: accept at: 9 main: '*' sub: '*' quality: 1.0.
	
	acceptEncoding := WAAcceptEncoding fromString: 'gzip, deflate'.
	self assert: acceptEncoding size = 2.
	self assert: acceptEncoding at: 1 encoding: 'gzip' quality: 1.0.
	self assert: acceptEncoding at: 2 encoding: 'deflate' quality: 1.0.
	
	acceptLanguage := WAAcceptLanguage fromString: 'de-ch'.
	self assert: acceptLanguage size = 1.
	self assert: acceptLanguage at: 1 language: 'de' country: 'ch' quality: 1.0! !

!WAAcceptTest methodsFor: 'testing' stamp: 'pmm 8/28/2009 08:35'!
testMozilla
	| accept accpetLanguage acceptCharset acceptEncoding |
	accept := WAAccept fromString: 'text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5'.
	self assert: accept size = 7.
	self assert: accept at: 1 main: 'text' sub: 'xml' quality: 1.0.
	self assert: accept at: 2 main: 'application' sub: 'xml' quality: 1.0.
	self assert: accept at: 3 main: 'application' sub: 'xhtml+xml' quality: 1.0.
	self assert: accept at: 4 main: 'text' sub: 'html' quality: 0.9.
	self assert: accept at: 5 main: 'text' sub: 'plain' quality: 0.8.
	self assert: accept at: 6 main: 'image' sub: 'png' quality: 1.0.
	self assert: accept at: 7 main: '*' sub: '*' quality: 0.5.
	
	acceptCharset := WAAcceptCharset fromString: 'ISO-8859-1,utf-8;q=0.7,*;q=0.7'.
	self assert: acceptCharset size = 3.
	self assert: acceptCharset at: 1 charset: 'ISO-8859-1' quality: 1.0.
	self assert: acceptCharset at: 2 charset: 'utf-8' quality: 0.7.
	self assert: acceptCharset at: 3 charset: '*' quality: 0.7.
	
	acceptEncoding := WAAcceptEncoding fromString: 'gzip,deflate'.
	self assert: acceptEncoding size = 2.
	self assert: acceptEncoding at: 1 encoding: 'gzip' quality: 1.0.
	self assert: acceptEncoding at: 2 encoding: 'deflate' quality: 1.0.
	
	accpetLanguage := WAAcceptLanguage fromString: 'de-de,de;q=0.8,en-us;q=0.5,en;q=0.3'.
	self assert: accpetLanguage size = 4.
	self assert: accpetLanguage at: 1 language: 'de' country: 'de' quality: 1.0.
	self assert: accpetLanguage at: 2 language: 'de' country: nil quality: 0.8.
	self assert: accpetLanguage at: 3 language: 'en' country: 'us' quality: 0.5.
	self assert: accpetLanguage at: 4 language: 'en' country: nil quality: 0.3.! !

TestCase subclass: #WABacktrackingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WABacktrackingTest methodsFor: 'testing' stamp: 'lr 3/15/2008 18:04'!
testArray
	| original snapshot1 snapshot2 snapshot3 |

	original := Array with: 1 with: 2 with: 3.
	snapshot1 := original snapshotCopy.

	original at: 1 put: #a.
	snapshot2 := original snapshotCopy.

	original at: 2 put: #b.
	snapshot3 := original snapshotCopy.

	original restoreFromSnapshot: snapshot1.
	self assert: original = #( 1 2 3 ).

	original restoreFromSnapshot: snapshot2.
	self assert: original = #( a 2 3 ).

	original restoreFromSnapshot: snapshot3.
	self assert: original = #( a b 3 )! !

!WABacktrackingTest methodsFor: 'testing' stamp: 'pmm 11/6/2007 20:34'!
testBag
	| original snapshot1 snapshot2 snapshot3 |

	original := Bag with: 1 with: 2.
	snapshot1 := original snapshotCopy.

	original add: 3.
	snapshot2 := original snapshotCopy.

	original remove: 1.
	snapshot3 := original snapshotCopy.

	original restoreFromSnapshot: snapshot1.
	self assert: original size = 2.
	self assert: (original includes: 1).
	self assert: (original includes: 2).
	self deny: (original includes: 3).

	original restoreFromSnapshot: snapshot2.
	self assert: original size = 3.
	self assert: (original includes: 1).
	self assert: (original includes: 2).
	self assert: (original includes: 3).

	original restoreFromSnapshot: snapshot3.
	self assert: original size = 2.
	self deny: (original includes: 1).
	self assert: (original includes: 2).
	self assert: (original includes: 3).

	original add: 4.
	original restoreFromSnapshot: snapshot3.
	self assert: original size = 2.
	self deny: (original includes: 1).
	self assert: (original includes: 2).
	self assert: (original includes: 3).
	self deny: (original includes: 4)! !

!WABacktrackingTest methodsFor: 'testing' stamp: 'lr 3/25/2008 22:14'!
testDictionary
	| original snapshot1 snapshot2 snapshot3 snapshot4 |

	original := Dictionary new.
	original at: 1 put: #a; at: 2 put: #b.
	snapshot1 := original snapshotCopy.

	original at: 3 put: #c.
	snapshot2 := original snapshotCopy.

	original at: 3 put: #d.
	snapshot3 := original snapshotCopy.

	original removeKey: 1.
	snapshot4 := original snapshotCopy.

	original restoreFromSnapshot: snapshot1.
	self assert: original size = 2.
	self assert: (original at: 1 ifAbsent: []) = #a.
	self assert: (original at: 2 ifAbsent: []) = #b.
	self assert: (original at: 3 ifAbsent: []) isNil.
	self assert: (original at: 4 ifAbsent: []) isNil.

	original restoreFromSnapshot: snapshot2.
	self assert: (original at: 1 ifAbsent: []) = #a.
	self assert: (original at: 2 ifAbsent: []) = #b.
	self assert: (original at: 3 ifAbsent: []) = #c.
	self assert: (original at: 4 ifAbsent: []) isNil.

	original restoreFromSnapshot: snapshot3.
	self assert: (original at: 1 ifAbsent: []) = #a.
	self assert: (original at: 2 ifAbsent: []) = #b.
	self assert: (original at: 3 ifAbsent: []) = #d.
	self assert: (original at: 4 ifAbsent: []) isNil.

	original restoreFromSnapshot: snapshot4.
	self assert: (original at: 1 ifAbsent: []) isNil.
	self assert: (original at: 2 ifAbsent: []) = #b.
	self assert: (original at: 3 ifAbsent: []) = #d.
	self assert: (original at: 4 ifAbsent: []) isNil.

	original at: 2 put: #!!.
	original restoreFromSnapshot: snapshot4.
	self assert: (original at: 1 ifAbsent: []) isNil.
	self assert: (original at: 2 ifAbsent: []) = #b.
	self assert: (original at: 3 ifAbsent: []) = #d.
	self assert: (original at: 4 ifAbsent: []) isNil! !

!WABacktrackingTest methodsFor: 'testing' stamp: 'lr 3/25/2008 22:13'!
testHolder
	| original snapshot1 snapshot2 snapshot3 |
	original := WAValueHolder new.
	snapshot1 := original snapshotCopy.
	original contents: 1.
	snapshot2 := original snapshotCopy.
	original contents: 2.
	snapshot3 := original snapshotCopy.
	original restoreFromSnapshot: snapshot1.
	self assert: original contents isNil.
	original restoreFromSnapshot: snapshot2.
	self assert: original contents = 1.
	original restoreFromSnapshot: snapshot3.
	self assert: original contents = 2! !

!WABacktrackingTest methodsFor: 'testing' stamp: 'pmm 2/14/2008 21:09'!
testObject
	| original snapshot |

	original := Object new.
	snapshot := original snapshotCopy.
	original restoreFromSnapshot: snapshot! !

!WABacktrackingTest methodsFor: 'testing' stamp: 'lr 11/16/2007 17:10'!
testOrderedCollection
	| original snapshot |

	original := OrderedCollection with: 1 with: 2.
	snapshot := original snapshotCopy.
	
	original restoreFromSnapshot: snapshot.
	self assert: original asArray = #(1 2).
	
	original removeLast.
	
	original restoreFromSnapshot: snapshot.
	self assert: original asArray = #(1 2)! !

!WABacktrackingTest methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
testSet
	| original snapshot1 snapshot2 snapshot3 |

	original := Set with: 1 with: 2.
	snapshot1 := original snapshotCopy.

	original add: 3.
	snapshot2 := original snapshotCopy.

	original remove: 1.
	snapshot3 := original snapshotCopy.

	original restoreFromSnapshot: snapshot1.
	self assert: original size = 2.
	self assert: (original includes: 1).
	self assert: (original includes: 2).
	self deny: (original includes: 3).

	original restoreFromSnapshot: snapshot2.
	self assert: original size = 3.
	self assert: (original includes: 1).
	self assert: (original includes: 2).
	self assert: (original includes: 3).

	original restoreFromSnapshot: snapshot3.
	self assert: original size = 2.
	self deny: (original includes: 1).
	self assert: (original includes: 2).
	self assert: (original includes: 3).

	original add: 4.
	original restoreFromSnapshot: snapshot3.
	self assert: original size = 2.
	self deny: (original includes: 1).
	self assert: (original includes: 2).
	self assert: (original includes: 3).
	self deny: (original includes: 4)! !

TestCase subclass: #WACallbackTest
	instanceVariableNames: 'registry log'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WACallbackTest methodsFor: 'utilities' stamp: 'lr 12/28/2008 13:26'!
assertLog: aCollection
	self
		assert: log asArray = aCollection asArray
		description: 'Expected ' , aCollection asArray printString , ', but got ' , log asArray printString.
	log := OrderedCollection new! !

!WACallbackTest methodsFor: 'utilities' stamp: 'jf 7/31/2009 12:39'!
request: aDictionary
	"Processes a request with the fields given in aDictionary."
	
	| request context |
	request := WARequest new setFields: aDictionary; yourself.
	context := WARequestContext request: request response: WAResponse new.
	registry handle: context! !

!WACallbackTest methodsFor: 'running' stamp: 'lr 12/28/2008 16:14'!
setUp
	super setUp.
	registry := WACallbackRegistry new.
	log := OrderedCollection new! !

!WACallbackTest methodsFor: 'testing-callbacks' stamp: 'jf 9/30/2009 00:26'!
testActionCallback
	| key1 key2 |
	key1 := registry store: (WAActionCallback on: [ log add: 1 ]).
	key2 := registry store: (WAActionCallback on: [ log add: 2 ]).

	" trigger first callback "
	self 
		should: 
			[ self request: (GRSmallDictionary new
					at: key1
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 ).

	" trigger second callback "
	self 
		should: 
			[ self request: (GRSmallDictionary new
					at: key2
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(2 ).

	" first callback has priority "
	self 
		should: 
			[ self request: (GRSmallDictionary new
					at: key2
						put: nil;
					at: key1
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 ).

	" first callback is only triggered once "
	self 
		should: 
			[ self request: (GRSmallDictionary new
					at: key1
						put: nil;
					at: key1
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 )! !

!WACallbackTest methodsFor: 'testing' stamp: 'lr 12/28/2008 12:42'!
testAdvanceKey
	self assert: registry advanceKey = '1'.
	self assert: registry advanceKey = '2'.
	self assert: registry advanceKey = '3'! !

!WACallbackTest methodsFor: 'testing-callbacks' stamp: 'jf 9/30/2009 00:26'!
testCancelCallback
	| keyValue keySave keyCancel |
	keyValue := registry store: (WAValueCallback on: [ :v | log add: v ]).
	keySave := registry store: (WAActionCallback on: [ log add: 'save' ]).
	keyCancel := registry store: (WACancelActionCallback on: [ log add: 'cancel' ]).

	" a save callback "
	self 
		should: 
			[ self request: (GRSmallDictionary new
					at: keyValue
						put: 'a';
					at: keySave
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #('a' 'save' ).
	self 
		should: 
			[ self request: (GRSmallDictionary new
					at: keySave
						put: nil;
					at: keyValue
						put: 'b';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #('b' 'save' ).

	" a cancel callback "
	self 
		should: 
			[ self request: (GRSmallDictionary new
					at: keyValue
						put: 'a';
					at: keyCancel
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #('cancel' ).
	self 
		should: 
			[ self request: (GRSmallDictionary new
					at: keyCancel
						put: nil;
					at: keyValue
						put: 'b';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #('cancel' )! !

!WACallbackTest methodsFor: 'testing-callbacks' stamp: 'jf 9/30/2009 00:26'!
testDefaultCallback
	| keyValue keySave keyDefault |
	keyValue := registry store: (WAValueCallback on: [ :v | log add: v ]).
	keySave := registry store: (WAActionCallback on: [ log add: 'save' ]).
	keyDefault := registry store: (WADefaultActionCallback on: [ log add: 'default' ]).

	" a save callback "
	self 
		should: 
			[ self request: (GRSmallDictionary new
					at: keyValue
						put: 'a';
					at: keySave
						put: nil;
					at: keyDefault
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #('a' 'save' ).
	self 
		should: 
			[ self request: (GRSmallDictionary new
					at: keyDefault
						put: nil;
					at: keySave
						put: nil;
					at: keyValue
						put: 'b';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #('b' 'save' ).

	" a default callback "
	self 
		should: 
			[ self request: (GRSmallDictionary new
					at: keyValue
						put: 'a';
					at: keyDefault
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #('a' 'default' ).
	self 
		should: 
			[ self request: (GRSmallDictionary new
					at: keyDefault
						put: nil;
					at: keyValue
						put: 'b';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #('b' 'default' )! !

!WACallbackTest methodsFor: 'testing-callbacks' stamp: 'jf 9/30/2009 00:26'!
testDispatchCallback
	| key key1 key2 |
	key := registry store: WADispatchCallback new.
	key1 := registry store: (WAValueCallback on: 
			[ :v | 
			log
				add: 1;
				add: v ]).
	key2 := registry store: (WAValueCallback on: 
			[ :v | 
			log
				add: 2;
				add: v ]).

	" an empty callback "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #().

	" another empty callback "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: '';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #().

	" the first callback "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: key1;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 '' ).

	" the second callback within array "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: (Array with: key2);
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(2 '' )! !

!WACallbackTest methodsFor: 'testing-callbacks' stamp: 'jf 9/30/2009 00:26'!
testImageCallback
	| key |
	key := registry store: (WAImageCallback on: [ log add: 1 ]).

	" an invalid callback "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #().

	" a valid callback "
	self 
		should: 
			[ self request: (GRSmallDictionary new
					at: key , '.x'
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 )! !

!WACallbackTest methodsFor: 'testing-callbacks' stamp: 'jf 9/30/2009 00:26'!
testMapCallback
	| key |
	key := registry store: (WAMapCallback on: [ :v | log add: v ]).

	" valid "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: '?1,2';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: (Array with: 1 @ 2).

	" valid "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: '?1,23';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: (Array with: 1 @ 23).

	" valid "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: '?12,34';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: (Array with: 12 @ 34).

	" invalid: no value "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #().

	" invalid: empty string "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: '';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #().

	" invalid: invalid syntax "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: '1,2';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #().

	" invalid: invalid syntax "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: '?1';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #().

	" invalid: invalid syntax "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: '?1,';
					yourself) ]
		raise: WARenderNotification.

	" invalid: invalid syntax "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: '?1x2';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #().

	" invalid: invalid syntax "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: '?a,b';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #()! !

!WACallbackTest methodsFor: 'testing-callbacks' stamp: 'jf 9/30/2009 00:26'!
testMultiDispatchCallback
	| key key1 key2 |
	key := registry store: WAMultiDispatchCallback new.
	key1 := registry store: (WAValueCallback on: 
			[ :v | 
			log
				add: 1;
				add: v ]).
	key2 := registry store: (WAValueCallback on: 
			[ :v | 
			log
				add: 2;
				add: v ]).

	" an empty callback "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #().

	" another empty callback "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: '';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #().

	" the first callback "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: key1;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 '' ).

	" the second callback within array "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: (Array with: key2);
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(2 '' ).

	" the first and second callback "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: (Array 
								with: key1
								with: key2);
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 '' 2 '' ).

	" the second and first callback "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: (Array 
								with: key2
								with: key1);
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 '' 2 '' )! !

!WACallbackTest methodsFor: 'testing' stamp: 'lr 12/28/2008 12:42'!
testNextKey
	self assert: registry nextKey = '1'.
	registry increaseKey.
	self assert: registry nextKey = '2'.
	self assert: registry nextKey = '2'! !

!WACallbackTest methodsFor: 'testing-callbacks' stamp: 'jf 9/30/2009 00:26'!
testUploadCallback
	| key file |
	key := registry store: (WAUploadCallback on: [ :v | log add: v ]).

	" nil uploads are ignored "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #().

	" string uploads are ignored "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: 'foo';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #().

	" WAFile uploads are triggered "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key
						put: (file := WAFile new);
					yourself) ]
		raise: WARenderNotification.
	self assertLog: (Array with: file)! !

!WACallbackTest methodsFor: 'testing-callbacks' stamp: 'jf 9/30/2009 00:26'!
testValueCallback
	| key1 key2 |
	key1 := registry store: (WAValueCallback on: 
			[ :v | 
			log
				add: 1;
				add: v ]).
	key2 := registry store: (WAValueCallback on: 
			[ :v | 
			log
				add: 2;
				add: v ]).

	" a single value callback with nil "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key1
						put: nil;
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 '' ).

	" a single value callback with an empty string "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key1
						put: '';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 '' ).

	" a single value callback with a string "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key1
						put: 'foo';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 'foo' ).

	" a single value callback with an empty collection "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key1
						put: #();
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 '' ).

	" a single value callback with a collection with nil "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key1
						put: #(nil );
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 '' ).

	" a single value callback with an filled collection "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key1
						put: #('foo' 'bar' );
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 'foo' ).

	" two callbacks in order "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key1
						put: 'b';
					at: key2
						put: 'c';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 'b' 2 'c' ).

	" two callbacks not in order "
	self 
		shouldnt: 
			[ self request: (GRSmallDictionary new
					at: key2
						put: 'c';
					at: key1
						put: 'b';
					yourself) ]
		raise: WARenderNotification.
	self assertLog: #(1 'b' 2 'c' )! !

TestCase subclass: #WACollectionMimeDocumentTest
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WACollectionMimeDocumentTest methodsFor: 'running' stamp: 'lr 10/18/2008 16:47'!
setUp
	super setUp.
	document := WAMimeDocument on: 'aString' mimeType: WAMimeType textPlain! !

!WACollectionMimeDocumentTest methodsFor: 'testing' stamp: 'jf 9/24/2008 20:44'!
testAsMIMEDocument

	self assert: document seasideMimeDocument == document! !

!WACollectionMimeDocumentTest methodsFor: 'testing' stamp: 'pmm 4/16/2008 07:16'!
testContent

	self assert: document content = 'aString'! !

!WACollectionMimeDocumentTest methodsFor: 'testing' stamp: 'pmm 4/16/2008 07:09'!
testContentStream
	| stream |	
	stream := document contentStream.
	'aString' do: [ :each |
		self deny: stream atEnd.
		self assert: stream next = each ].
	
	self assert: stream atEnd! !

TestCase subclass: #WAConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAConfigurationTest methodsFor: 'accessing' stamp: 'jf 7/29/2008 18:12'!
basicSystemConfiguration
	^ WAConfigurationMock new
		description: [ :config | (config string: #a) default: #default ];
		yourself! !

!WAConfigurationTest methodsFor: 'tests' stamp: 'jf 7/24/2008 19:38'!
testCircular
	"Circular ancestry graphs are not allowed."
	| first second third |
	first := WAUserConfiguration new.
	second := WAUserConfiguration new
		addParent: first;
		yourself.
	third := WAUserConfiguration new
		addParent: second;
		yourself.
	self 
		should: [ first addParent: third ]
		raise: Error.
	self 
		should: [ first addParent: first ]
		raise: Error! !

!WAConfigurationTest methodsFor: 'tests' stamp: 'lr 10/22/2008 09:45'!
testCollectionInheritance
	"Collection values assigned with #at:addAll: should add on to the inherited value."
	| empty root one two three four |
	empty := WAConfigurationMock new
		description: [ :config | (config collection: #a) ];
		yourself.
	root := WAConfigurationMock new
		description: [ :config | (config collection: #a) default: #(1 2) ];
		yourself.
	one := WAConfigurationMock new
		description: [ :config | config at: #a addAll: #(3) removeAll: #(2) ];
		parents: [ Array with: root ];
		yourself.
	two := WAConfigurationMock new
		description: [ :config | config at: #a addAll: #(1 2 3 4) ];
		parents: [ Array with: one ];
		yourself.
	three := WAUserConfiguration new
		addParent: two;
		at: #a addAll: #(4 5) removeAll: #(1 8);
		yourself.
	four := WAConfigurationMock new
		description: [ :config | config at: #a addAll: #(3 4) removeAll: #(2 3) ];
		parents: [ Array with: one ];
		yourself.

	self assert: (empty at: #a) = #().
	self assert: (root at: #a) = #(1 2).
	self assert: (one at: #a) = #(1 3).
	self assert: (two at: #a) = #(1 2 3 4).
	self assert: (three at: #a) = #(2 3 4 5).
	self assert: (four at: #a) = #(1 3 4)! !

!WAConfigurationTest methodsFor: 'tests' stamp: 'jf 10/5/2008 14:51'!
testDefaultNeverOverrides
	"A default value should never override a specified value, even if the default is inherited from a later parent."
	| root withValue withoutValue withThenWithout withoutThenWith |
	root := self basicSystemConfiguration.
	withValue := WAUserConfiguration new
		addParent: root;
		yourself.
	withValue 
		at: #a
		put: #value.
	withoutValue := WAUserConfiguration new
		addParent: root;
		yourself.
	withThenWithout := WAUserConfiguration new
		addParent: withValue;
		addParent: withoutValue;
		yourself.
	withoutThenWith := WAUserConfiguration new
		addParent: withoutValue;
		addParent: withValue;
		yourself.
	self assert: (root at: #a) = #default.
	self assert: (withValue at: #a) = #value.
	self assert: (withoutValue at: #a) = #default.
	self assert: (withThenWithout at: #a) = #value.
	self assert: (withoutThenWith at: #a) = #value! !

!WAConfigurationTest methodsFor: 'tests' stamp: 'jf 10/5/2008 14:51'!
testLastAddedOverrides
	"If a non-default value is inherited from more than one parent, the one from the last parent in the list should take precedence.
	
	These are the two graphs we are talking abou0 (X means no value specified):
  top                   mirror
  /  \                    /  \
 2    X                  X   2
 |     |                   |    |
 X    1                  1   X
  \  /                    \  /
  root                   root
"
	| root aX a2 b1 bX top mirror |
	root := self basicSystemConfiguration.
	aX := WAUserConfiguration new
		addParent: root;
		yourself.
	a2 := WAUserConfiguration new
		addParent: aX;
		yourself.
	a2 
		at: #a
		put: 2.
	b1 := WAUserConfiguration new
		addParent: root;
		yourself.
	b1 
		at: #a
		put: 1.
	bX := WAUserConfiguration new
		addParent: b1;
		yourself.
	top := WAUserConfiguration new
		addParent: a2;
		addParent: bX;
		yourself.
	mirror := WAUserConfiguration new
		addParent: bX;
		addParent: a2;
		yourself.
	self assert: (root at: #a) = #default.
	self assert: (aX at: #a) = #default.
	self assert: (a2 at: #a) = 2.
	self assert: (b1 at: #a) = 1.
	self assert: (bX at: #a) = 1.
	self assert: (top at: #a) = 1.
	self assert: (mirror at: #a) = 2! !

!WAConfigurationTest methodsFor: 'tests' stamp: 'jf 10/5/2008 14:50'!
testLastAddedOverrides2
	"If a non-default value is inherited from more than one parent, the one from the last parent in the list should take precedence.
	
	These are the two graphs we are talking abou0 (X means no value specified):
    top                mirror
    / \                  |   |
    |  2                 2   |
    | /                    \ |
    1                       1
    |                        |  
  root                    root
"
	| root top mirror one two |
	root := self basicSystemConfiguration.
	one := WAUserConfiguration new
		addParent: root;
		yourself.
	one 
		at: #a
		put: 1.
	two := WAUserConfiguration new
		addParent: one;
		yourself.
	two 
		at: #a
		put: 2.
	top := WAUserConfiguration new
		addParent: one;
		addParent: two;
		yourself.
	mirror := WAUserConfiguration new
		addParent: two;
		addParent: one;
		yourself.
	self assert: (root at: #a) = #default.
	self assert: (one at: #a) = 1.
	self assert: (two at: #a) = 2.
	self assert: (top at: #a) = 2.
	self assert: (mirror at: #a) = 1! !

!WAConfigurationTest methodsFor: 'tests' stamp: 'jf 10/5/2008 14:50'!
testOverrides
	"A value in a configuration should override all those given by its ancestors."
	| root one two three four system five |
	root := self basicSystemConfiguration.
	one := WAUserConfiguration new
		addParent: root;
		yourself.
	two := WAUserConfiguration new
		addParent: one;
		yourself.
	two at: #a put: 2.
	system := WAConfigurationMock new
		description: [ :config | config at: #a put: #override ];
		parents: [ Array with: two ];
		yourself.
	three := WAUserConfiguration new
		addParent: system;
		yourself.
	four := WAUserConfiguration new
		addParent: three;
		yourself.
	four at: #a put: 4.
	five := WAUserConfiguration new
		addParent: four;
		yourself.
	self assert: (root at: #a) = #default.
	self assert: (one at: #a) = #default.
	self assert: (two at: #a) = 2.
	self assert: (system at: #a) = #override.
	self assert: (three at: #a) = #override.
	self assert: (four at: #a) = 4.
	self assert: (five at: #a) = 4! !

!WAConfigurationTest methodsFor: 'tests' stamp: 'jf 10/5/2008 14:48'!
testValueWithoutAttribute
	"A user configuration should not be able to provide a value if it does not inherit the attribute."
	| root user top mirror |
	root := self basicSystemConfiguration.
	user := WAUserConfiguration new
		addParent: root;
		yourself.
	user 
		at: #a
		put: 1.
	user removeParent: root.
	top := WAUserConfiguration new
		addParent: root;
		addParent: user;
		yourself.
	mirror := WAUserConfiguration new
		addParent: user;
		addParent: root;
		yourself.
	self assert: (root at: #a) = #default.
	self should: [ user at: #a ] raise: WAAttributeNotFound.
	self assert: (top at: #a) = #default.
	self assert: (mirror at: #a) = #default.
	self 
		should: 
			[ user 
				at: #a
				put: 2 ]
		raise: Error! !

!WAConfigurationTest methodsFor: 'tests' stamp: 'jf 10/5/2008 14:47'!
testValueWithoutAttribute2
	"A user configuration should not be able to provide a value if it does not inherit the attribute."
	| root top mirror user1 user2 |
	root := self basicSystemConfiguration.
	user1 := WAUserConfiguration new
		addParent: root;
		yourself.
	user1 
		at: #a
		put: 1.
	user2 := WAUserConfiguration new
		addParent: root;
		yourself.
	user2 
		at: #a
		put: 2.
	user2 removeParent: root.
	top := WAUserConfiguration new
		addParent: user1;
		addParent: user2;
		yourself.
	mirror := WAUserConfiguration new
		addParent: user2;
		addParent: user1;
		yourself.
	self assert: (root at: #a) = #default.
	self assert: (user1 at: #a) = 1.
	self should: [ user2 at: #a ] raise: WAAttributeNotFound.
	self assert: (top at: #a) = 1.
	self assert: (mirror at: #a) = 1! !

!WAConfigurationTest methodsFor: 'tests' stamp: 'pmm 11/3/2008 17:22'!
testValueWithoutDefault
	"Make sure that a configuration can specify a local value even if the attribute doesn't have a default value." 	
	| root1 root2 user |
	root1 := WAConfigurationMock new
		description: [ :config | config string: #a ];
		yourself.
	root2 := WAConfigurationMock new
		description: [ :config | config string: #b ];
		yourself.
	
	user := WAUserConfiguration new addParent: root1; addParent: root2; yourself.
	user at: #a put: 1.
	user at: #b put: 2.
	
	self assert: (root1 at: #a) isNil.
	self assert: (root2 at: #b) isNil.
	self assert: (user at: #a) = 1.
	self assert: (user at: #b) = 2.! !

TestCase subclass: #WAContextTest
	instanceVariableNames: 'requestContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAContextTest commentStamp: 'pmm 5/11/2008 08:15' prior: 0!
A WAServerTest is the base class for all tests that need a server in the request context.
!

WAContextTest subclass: #WAAttributesTest
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAAttributesTest methodsFor: 'private' stamp: 'lr 2/4/2009 08:02'!
assert: aBlock gives: aString 
	| stream |
	aBlock value: (attributes := WAHtmlAttributes new).
	(WAHtmlDocument 
		on: (stream := WriteStream on: String new)
		codec: self requestContext codec) print: attributes.
	self 
		assert: stream contents = aString
		description: 'Expected ' , aString printString , ', but got ' , stream contents printString
		resumable: true! !

!WAAttributesTest methodsFor: 'running' stamp: 'lr 7/12/2007 13:28'!
setUp
	attributes := WAHtmlAttributes new! !

!WAAttributesTest methodsFor: 'testing-convenience' stamp: 'lr 10/28/2007 14:42'!
testAddClass
	self
		assert: [ :attr | attr addClass: 'foo' ]
		gives: ' class="foo"'.
	self
		assert: [ :attr | attr addClass: 'foo'; addClass: 'bar' ]
		gives: ' class="foo bar"'! !

!WAAttributesTest methodsFor: 'testing-convenience' stamp: 'lr 10/28/2007 14:42'!
testAddStyle
	self
		assert: [ :attr | attr addStyle: 'display: hidden' ]
		gives: ' style="display: hidden"'.
	self
		assert: [ :attr | attr addStyle: 'display: hidden'; addStyle: 'position: absolute' ]
		gives: ' style="display: hidden;position: absolute"'! !

!WAAttributesTest methodsFor: 'testing' stamp: 'lr 7/12/2007 13:29'!
testAt
	attributes at: 'foo' put: 'bar'.
	self assert: (attributes at: 'foo') = 'bar'.
	self assert: (attributes at: 'bar') isNil! !

!WAAttributesTest methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
testAtAppend
	self
		assert: [ :attr | attr at: 'onclick' append: 'this' separator: ';' ]
		gives: ' onclick="this"'.
	self
		assert: [ :attr |
			attr
				at: 'onclick' append: 'this' separator: ';';
				at: 'onclick' append: 'that' separator: ';' ]
		gives: ' onclick="this;that"'.
	self
		assert: [ :attr |
			attr
				at: 'onclick' append: 'this' separator: ';';
				at: 'onclick' append: nil separator: ';' ]
		gives: ' onclick="this"'.
	self
		assert: [ :attr |
			attr
				at: 'onclick' append: 1 separator: ';';
				at: 'onclick' append: 2 separator: ';' ]
		gives: ' onclick="1;2"'! !

!WAAttributesTest methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
testAtPut
	self
		assert: [ :attr | attr at: 'id' put: 'foo' ]
		gives: ' id="foo"'.
	self
		assert: [ :attr | attr at: 'tabindex' put: 6 ]
		gives: ' tabindex="6"'.
	self
		assert: [ :attr | attr at: 'checked' put: true ]
		gives: ' checked="checked"'.
	self
		assert: [ :attr | attr at: 'readonly' put: false ]
		gives: ''.
	self
		assert: [ :attr | attr at: 'disabled' put: nil ]
		gives: ''! !

!WAAttributesTest methodsFor: 'testing-fixtures' stamp: 'lr 4/6/2007 21:18'!
testCaseSensititve
	self
		assert: [ :attr | attr at: 'lastBuildDate' put: 'Sat, 07 Sep 2002 09:42:31 GMT' ]
		gives: ' lastBuildDate="Sat, 07 Sep 2002 09:42:31 GMT"'! !

!WAAttributesTest methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
testOrder
	self
		assert: [ :attr | attr at: 'a' put: 1; at: 'b' put: 2; at: 'c' put: 3 ]
		gives: ' a="1" b="2" c="3"'.
	self
		assert: [ :attr | attr at: 'a' put: 1; at: 'b' put: 2; at: 'c' put: 3; at: 'b' put: 4 ]
		gives: ' a="1" b="4" c="3"'! !

!WAAttributesTest methodsFor: 'testing' stamp: 'lr 7/12/2007 13:29'!
testRemoveKey
	attributes at: 'id' put: 'foo'.
	self assert: (attributes removeKey: 'id') = 'foo'.
	self assert: (attributes removeKey: 'id') isNil! !

WAContextTest subclass: #WACacheTest
	instanceVariableNames: 'cache key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WACacheTest methodsFor: 'running' stamp: 'lr 1/10/2009 12:49'!
setUp
	cache := WACache new.
	key := WAKeyGenerator current keyOfLength: 8! !

!WACacheTest methodsFor: 'testing' stamp: 'lr 10/4/2008 19:52'!
testAt
	self assert: (cache at: key) isNil.
	self assert: (cache at: (cache store: 1)) = 1! !

!WACacheTest methodsFor: 'testing' stamp: 'lr 10/4/2008 19:53'!
testAtIfAbsent
	self assert: (cache at: key ifAbsent: [ 0 ]) = 0.
	self assert: (cache at: (cache store: 1) ifAbsent: [ 0 ]) = 1! !

!WACacheTest methodsFor: 'testing' stamp: 'jf 2/6/2009 19:24'!
testClear
	key := cache store: 1.
	cache clear.
	self assert: (cache at: key) isNil.
	self assert: (cache keyAtValue: 1) isNil! !

!WACacheTest methodsFor: 'testing' stamp: 'jf 2/6/2009 20:24'!
testCopy
	| one two copy |
	one := cache store: 1.
	two := cache store: 2.
	
	copy := cache copy.
	copy removeKey: one.
	
	self assert: (cache at: one) = 1.
	self assert: (cache at: two) = 2.
	self assert: (cache keyAtValue: 1) = one.
	self assert: (cache keyAtValue: 2) = two.
	self assert: (copy at: two) = 2.
	self assert: (copy keyAtValue: 2) = two.
	self assert: (copy keyAtValue: 1) isNil.
	self assert: (copy at: one) isNil.
	
	self deny: (cache instVarNamed: 'mutex') == (copy instVarNamed: 'mutex').
	self deny: cache expiryPolicy == copy expiryPolicy.
	self deny: cache missStrategy == copy missStrategy.
	self deny: cache removalAction == copy removalAction.
	self deny: cache reapingStrategy == copy reapingStrategy.! !

!WACacheTest methodsFor: 'testing' stamp: 'jf 2/6/2009 19:24'!
testKeyAtValue
	key := cache store: 1.
	self assert: (cache keyAtValue: 1) = key.
	self assert: (cache keyAtValue: 2) isNil! !

!WACacheTest methodsFor: 'testing-policies' stamp: 'jf 2/6/2009 20:22'!
testLastAccess
	| keys |
	cache setExpiryPolicy: WALastAccessExpiryPolicy new.
	keys := (1 to: 30) collect: [ :index | cache store: index ].
	cache reap.
	keys do: [ :each | self assert: (cache at: each) notNil ]! !

!WACacheTest methodsFor: 'testing-policies' stamp: 'jf 2/6/2009 20:22'!
testLeastRecentlyUsed
	| keys |
	cache setExpiryPolicy: WALeastRecentlyUsedExpiryPolicy new.
	keys := (1 to: 30) collect: [ :index | cache store: index ].
	cache reap.
	1 to: 9 do: [ :index | self assert: (cache at: (keys at: index)) isNil ].
	10 to: 30 do: [ :index | self assert: (cache at: (keys at: index)) = index ]! !

!WACacheTest methodsFor: 'testing-policies' stamp: 'jf 2/6/2009 20:23'!
testLeastRecentlyUsedCopy
	| keys1 keys2 cacheCopy |
	cache setExpiryPolicy: WALeastRecentlyUsedExpiryPolicy new.
	keys1 := (1 to: 20) collect: [ :index | cache store: index ].
	keys2 := keys1 copy.
	cacheCopy := cache copy.
	
	"touch different objects in each cache"
	1 to: 9 by: 2 do: [ :index | self assert: (cache at: (keys1 at: index)) notNil ].
	2 to: 8 by: 2 do: [ :index | self assert: (cacheCopy at: (keys2 at: index)) notNil ].

	"now overflow the caches"
	keys1 := keys1 , ((21 to: 30) collect: [ :index | cache store: index ]).
	keys2 := keys2 , ((21 to: 30) collect: [ :index | cacheCopy store: index ]).
	cache reap.
	cacheCopy reap.

	"verify that different caches expired different objects"
	1 to: 9 by: 2 do: [ :index | self assert: (cache at: (keys1 at: index)) notNil ].
	1 to: 9 by: 2 do: [ :index | self assert: (cacheCopy at: (keys2 at: index)) isNil ].

	2 to: 8 by: 2 do: [ :index | self assert: (cache at: (keys1 at: index)) isNil ].
	2 to: 8 by: 2 do: [ :index | self assert: (cacheCopy at: (keys2 at: index)) notNil ].

	10 to: 30 do: [ :index | self assert: (cache at: (keys1 at: index)) notNil ].
	10 to: 30 do: [ :index | self assert: (cacheCopy at: (keys2 at: index)) notNil ].! !

!WACacheTest methodsFor: 'testing' stamp: 'jf 2/6/2009 19:24'!
testRemove
	key := cache store: 1.
	self assert: (cache remove: 1) = 1.
	self assert: (cache at: key) isNil.
	self assert: (cache keyAtValue: 1) isNil! !

!WACacheTest methodsFor: 'testing' stamp: 'jf 2/6/2009 19:25'!
testRemoveKey
	key := cache store: 1.
	self assert: (cache removeKey: key) = 1.
	self assert: (cache at: key) isNil.
	self assert: (cache keyAtValue: 1) isNil! !

!WACacheTest methodsFor: 'testing' stamp: 'jf 2/6/2009 20:23'!
testRetrieve
	self assert: (cache at: key) isNil.
	key := cache store: 1.
	self assert: (cache at: key) = 1! !

!WACacheTest methodsFor: 'testing' stamp: 'pmm 11/4/2008 21:05'!
testSize
	self assert: cache isEmpty.
	cache store: #a.
	self assert: cache size = 1.
	cache store: #b.
	self assert: cache size = 2.
	cache remove: #a.
	self assert: cache size = 1.! !

!WAContextTest class methodsFor: 'testing' stamp: 'lr 1/21/2009 15:12'!
isAbstract
	^ self name = #WAContextTest! !

!WAContextTest methodsFor: 'configuration' stamp: 'jf 9/30/2009 00:27'!
createCodec
	^ GRNullCodec new! !

!WAContextTest methodsFor: 'configuration' stamp: 'lr 1/21/2009 15:05'!
createHandlers
	^ #()! !

!WAContextTest methodsFor: 'configuration' stamp: 'jf 7/31/2009 09:39'!
createRequest
	^ WARequest new! !

!WAContextTest methodsFor: 'configuration' stamp: 'lr 1/21/2009 15:03'!
createRequestContext
	^ WARequestContext request: self createRequest response: self createResponse codec: self createCodec! !

!WAContextTest methodsFor: 'configuration' stamp: 'lr 1/21/2009 15:03'!
createResponse
	^ WABufferedResponse new! !

!WAContextTest methodsFor: 'running' stamp: 'jgf 1/30/2009 14:24'!
performTest

	requestContext := self createRequestContext.
	WACurrentRequestContext 
		use: self requestContext
		during: [
			self
				pushAll: self createHandlers
				during: [ super performTest ] ]! !

!WAContextTest methodsFor: 'private' stamp: 'lr 1/21/2009 15:10'!
pushAll: aCollection during: aBlock
	^ aCollection isEmpty
		ifTrue: [ aBlock value ]
		ifFalse: [
			self requestContext
				push: aCollection first
				while: [ self pushAll: aCollection allButFirst during: aBlock ] ]! !

!WAContextTest methodsFor: 'accessing' stamp: 'lr 1/21/2009 15:11'!
requestContext
	^ requestContext! !

!WAContextTest methodsFor: 'utilities' stamp: 'lr 1/21/2009 20:10'!
requestContextWithUrl: aUrlOrString
	self requestContextWithUrl: aUrlOrString cookies: Array new! !

!WAContextTest methodsFor: 'utilities' stamp: 'jf 7/31/2009 12:40'!
requestContextWithUrl: aUrlOrString cookies: aCollection
	| handlers |
	handlers := self requestContext handlers.
	self requestContext
		initializeWithRequest: 
			((WARequest method: 'GET' uri: aUrlOrString)
				setCookies: aCollection asArray;
				yourself)
		response: WABufferedResponse new
		codec: self createCodec.
	self requestContext handlers addAll: handlers! !

!WAContextTest methodsFor: 'utilities' stamp: 'lr 1/21/2009 20:27'!
responseAfter: aBlock
	self requestContext response initialize.
	aBlock on: WAResponseNotification do: [ :n | ].
	^ self requestContext response! !

WAContextTest subclass: #WADocumentHandlerResponseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WADocumentHandlerResponseTest methodsFor: 'private' stamp: 'pmm 2/20/2009 09:57'!
assertHttpResponseFrom: aResponse matches: aHandler
	| expectedContents actualContents |
	self assert: aResponse status = 200.
	self assert: aResponse contentType = aHandler document mimeType.
	expectedContents := aHandler document contents.
	actualContents := aResponse contents.
	self assert: actualContents size = expectedContents size.
	self assert: actualContents species = expectedContents species.
	self assert: aResponse cookies isEmpty! !

!WADocumentHandlerResponseTest methodsFor: 'private' stamp: 'jok 8/3/2009 09:11'!
createAndVerifyBinaryDocumentNamed: aFilename hasAttachment: aHttpHeaderValue
	self
		createAndVerifyDocumentNamed: aFilename
		content: WATestingFiles default samplePng
		mimeType: WAMimeType imagePng
		hasAttachment: aHttpHeaderValue! !

!WADocumentHandlerResponseTest methodsFor: 'private' stamp: 'jok 8/3/2009 09:12'!
createAndVerifyDocumentNamed: aFilename content: anObject mimeType: aMimeTypeString hasAttachment: aHttpHeaderValue
	| handler response |
	handler := WADocumentHandler
		document: anObject
		mimeType: aMimeTypeString
		fileName: aFilename.
	self assert: handler document contents = anObject.
	response := self responseAfter: [ handler handle: self requestContext ].
	self assert: (self headerAt: 'Expires' forResponse: response) notNil.
	self assert: (self headerAt: 'Content-Disposition' forResponse: response) = aHttpHeaderValue.
	self assertHttpResponseFrom: response matches: handler! !

!WADocumentHandlerResponseTest methodsFor: 'private' stamp: 'jok 8/3/2009 09:12'!
createAndVerifyTextDocumentNamed: aFilename hasAttachment: aHttpHeaderValue
	self
		createAndVerifyDocumentNamed: aFilename
		content: 'body { background-color: #ffffff }'
		mimeType: WAMimeType textCss
		hasAttachment: aHttpHeaderValue! !

!WADocumentHandlerResponseTest methodsFor: 'private' stamp: 'lr 1/21/2009 20:21'!
headerAt: aString forResponse: aResponse
	^ aResponse headerAt: aString! !

!WADocumentHandlerResponseTest methodsFor: 'testing' stamp: 'jok 8/3/2009 09:13'!
testByteArrayWithFilename
	self
		createAndVerifyBinaryDocumentNamed: 'sample.png'
		hasAttachment: 'attachment; filename="sample.png"'! !

!WADocumentHandlerResponseTest methodsFor: 'testing' stamp: 'jok 8/3/2009 09:13'!
testByteArrayWithoutFilename
	self
		createAndVerifyBinaryDocumentNamed: nil
		hasAttachment: nil! !

!WADocumentHandlerResponseTest methodsFor: 'testing' stamp: 'jok 8/3/2009 09:14'!
testStringWithFilename
	self
		createAndVerifyTextDocumentNamed: 'toolbar.css'
		hasAttachment: 'attachment; filename="toolbar.css"'! !

!WADocumentHandlerResponseTest methodsFor: 'testing' stamp: 'jok 8/3/2009 09:14'!
testStringWithoutFilename
	self
		createAndVerifyTextDocumentNamed: nil
		hasAttachment: nil! !

WAContextTest subclass: #WAEncoderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAEncoderTest class methodsFor: 'testing' stamp: 'lr 2/7/2009 22:34'!
shouldInheritSelectors
	^ true! !

!WAEncoderTest methodsFor: 'private' stamp: 'jf 1/23/2009 14:49'!
assert: aString encoder: aClass gives: anEncodedString
	| actual |
	actual := String streamContents: [ :stream |
		(aClass on: stream codec: self requestContext codec) nextPutAll: aString ].
	self assert: actual = anEncodedString! !

!WAEncoderTest methodsFor: 'testing' stamp: 'lr 4/7/2007 19:38'!
testEncodedHtml
	self assert: 'Seaside' encoder: WAHtmlEncoder gives: 'Seaside'.
	self assert: '<div id="&amp;">' encoder: WAHtmlEncoder gives: '&lt;div id=&quot;&amp;amp;&quot;&gt;'! !

!WAEncoderTest methodsFor: 'testing' stamp: 'lr 10/18/2008 12:15'!
testEncodedUrl
	self assert: 'Seaside Aubergines' encoder: WAUrlEncoder gives: 'Seaside%20Aubergines'.
	self assert: 'www.seaside.st' encoder: WAUrlEncoder gives: 'www.seaside.st'.
	self assert: '~seaside-info_' encoder: WAUrlEncoder gives: '~seaside-info_'.
	self assert: 'http://www.seaside.st?foo=1&bar=2' encoder: WAUrlEncoder gives: 'http%3A%2F%2Fwww.seaside.st%3Ffoo%3D1%26bar%3D2'.
	self assert: 'a%' encoder: WAUrlEncoder gives: 'a%25'.
	self assert: (String with: Character cr) encoder: WAUrlEncoder gives: '%0D'! !

WAContextTest subclass: #WAFileHandlerListingTest
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAFileHandlerListingTest class methodsFor: 'testing' stamp: 'MAD 2/21/2009 13:24'!
isAbstract
	^self name = #WAFileHandlerListingTest! !

!WAFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 14:46'!
assertLibrariesResponse: response
	self assert: (response contents 
					indexOfSubCollection: self expectedLibrariesContents 
					startingAt: 1
				) > 0! !

!WAFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 14:46'!
assertLibraryResponse: response
	self assert: (response contents
					indexOfSubCollection: self expectedLibraryContents
					startingAt: 1
				) > 0! !

!WAFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 14:53'!
expectedLibrariesContents
	^ (handler libraries detect: [ :each | true ]) name! !

!WAFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 15:13'!
expectedLibraryContents
	^ WATestingFiles default filenames detect: [ :each | true ]! !

!WAFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 13:42'!
expectedMimeType
	self subclassResponsibility! !

!WAFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 14:34'!
expectedStatus
	^ 200! !

!WAFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 13:41'!
handlerClass
	self subclassResponsibility! !

!WAFileHandlerListingTest methodsFor: 'testing' stamp: 'pmm 9/5/2009 10:48'!
testFileLibraries
	| response |
	handler := WAFileHandler new.
	handler preferenceAt: #fileHandlerListingClass put: self handlerClass.

	self requestContextWithUrl: '/i/dont/care/'.
	self requestContext consumer next; next; next.

	response := self responseAfter: [ handler handle: self requestContext ].

	self assert: response status = self expectedStatus.
	self assert: response contentType = self expectedMimeType.
	self assertLibrariesResponse: response.! !

!WAFileHandlerListingTest methodsFor: 'testing' stamp: 'pmm 9/5/2009 15:10'!
testFileLibrary
	| response |
	handler := WAFileHandler new.
	handler preferenceAt: #fileHandlerListingClass put: self handlerClass.
	self requestContextWithUrl: '/i/dont/care/WATestingFiles'.
	self requestContext consumer next; next; next.

	response := self responseAfter: [ handler handle: self requestContext ].

	self assert: response status = self expectedStatus.
	self assert: response contentType = self expectedMimeType.
	self assertLibraryResponse: response.! !

WAFileHandlerListingTest subclass: #WAForbiddenFileHandlerListingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAForbiddenFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 14:44'!
expectedLibrariesContents
	^ 'forbidden'! !

!WAForbiddenFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 14:44'!
expectedLibraryContents
	^ 'forbidden'! !

!WAForbiddenFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 14:10'!
expectedMimeType
	^ WAMimeType textPlain! !

!WAForbiddenFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 14:08'!
expectedStatus
	^ 403! !

!WAForbiddenFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 14:08'!
handlerClass
	^ WAForbiddenFileHandlerListing! !

WAFileHandlerListingTest subclass: #WATextFileHandlerListingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WATextFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 13:47'!
expectedMimeType
	^ WAMimeType textPlain! !

!WATextFileHandlerListingTest methodsFor: 'testing' stamp: 'MAD 2/21/2009 13:48'!
handlerClass
	^ WATextFileHandlerListing! !

WAContextTest subclass: #WAFileLibraryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAFileLibraryTest methodsFor: 'testing' stamp: 'jf 10/6/2008 17:18'!
testAsFileName
	| library |
	library := WATestingFiles default.
	self assert: (library asFilename: #mainJs) = 'main.js'.
	self assert: (library asFilename: #style2Css) = 'style2.css'.
	self assert: (library asFilename: #index) = 'index'! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 7/16/2007 20:13'!
testAsSelector
	self assert: (WAFileLibrary asSelector: 'main.css') = #mainCss.
	self assert: (WAFileLibrary asSelector: 'main.js') = #mainJs.
	self assert: (WAFileLibrary asSelector: 'style-2.css') = #style2Css.
	self assert: (WAFileLibrary asSelector: 'style_2.css') = #style2Css! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'jf 10/6/2008 17:18'!
testAsSelectorCapitalized
	| library |
	library := WATestingFiles default.
	self assert: (library asSelector: 'COMMENTS.TXT') = #COMMENTSTxt.
	self assert: (library asFilename: #COMMENTSTxt) = 'COMMENTS.txt'! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
testAsSelectorFunky
	self assert: (WAFileLibrary asSelector: '1_2$3-4/5()6!!7   8.9.test 1 2 3 me 4 5 6 .txt') = #test123me456Txt! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'jf 10/6/2008 17:20'!
testAsSelectorLeadingDigits
	| library |
	library := WATestingFiles default.
	self assert: (library asSelector: '1readme.txt') = #readmeTxt.
	self assert: (library asSelector: '123456789readme.txt') = #readmeTxt.
	self assert: (library asSelector: '123456789readme89.txt') = #readme89Txt! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'jgf 2/1/2009 09:20'!
testCompileByteArray
	| library file |
	[
		| data first second |
		library := WATestingFiles default.
		self deny: (library class selectors includes: #demoJpeg).
		data := (1 to: 255) asByteArray.
		file := WAFile new
			contentType: WAMimeType imageJpeg;
			contents: data;
			fileName: 'demo.jpeg';
			yourself.
		library addFile: file.
		self assert: (library class selectors includes: #demoJpeg).
		first := library perform: #demoJpeg.
		self assert: first = data.
		second := library perform: #demoJpeg.
		self assert: first = second.
	] ensure: [
		library removeFile: file fileName.
		self deny: (library class selectors includes: #demoJpeg).
	].! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'jgf 2/1/2009 09:19'!
testCompileByteArrayAgain
	| library file |
	[
		| data first second |
		library := WATestingFiles default.
		self deny: (library class selectors includes: #demoJpeg).
		data := (1 to: 255) asByteArray.
		file := WAFile new
			contentType: WAMimeType imageJpeg;
			contents: data;
			fileName: 'demo.jpeg';
			yourself.
		library addFile: file.
		self assert: (library class selectors includes: #demoJpeg).
		first := library perform: #demoJpeg.
		self assert: first = data.
		second := library perform: #demoJpeg.
		self assert: first = second.
	
		data := (1 to: 255) reverse asByteArray.
		file := WAFile new
			contentType: WAMimeType imageJpeg;
			contents: data;
			fileName: 'demo.jpeg';
			yourself.
		library addFile: file.
		self assert: (library class selectors includes: #demoJpeg).
		first := library perform: #demoJpeg.
		self assert: first = data.
		second := library perform: #demoJpeg.
		self assert: first = second.
	] ensure: [
		library removeFile: file fileName.
		self deny: (library class selectors includes: #demoJpeg).
	].! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'jgf 1/29/2009 09:27'!
testCompileString
	| library file |
	[
		| data first second |
		library := WATestingFiles default.
		self deny: (library class selectors includes: #demoTxt).
	
		data := 'this is a string'.
		file := WAFile new
			contentType: WAMimeType textPlain;
			contents: data;
			fileName: 'demo.txt';
			yourself.
	
		library addFile: file.
		self assert: (library class selectors includes: #demoTxt).
		first := library perform: #demoTxt.
		self assert: first = data.
		second := library perform: #demoTxt.
		self assert: first == second.
	] ensure: [
		library removeFile: file fileName.
		self deny: (library class selectors includes: #demoTxt).
	].! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'jgf 1/29/2009 09:27'!
testCompileStringAgain
	| library file |
	[
		| data first second |
		library := WATestingFiles default.
		self deny: (library class selectors includes: #demoTxt).
	
		data := 'this is a string'.
		file := WAFile new
			contentType: WAMimeType textPlain;
			contents: data;
			fileName: 'demo.txt';
			yourself.
	
		library addFile: file.
		self assert: (library class selectors includes: #demoTxt).
		first := library perform: #demoTxt.
		self assert: first = data.
		second := library perform: #demoTxt.
		self assert: first == second.
		data := 'this is another string'.
		file := WAFile new
			contentType: WAMimeType textPlain;
			contents: data;
			fileName: 'demo.txt';
			yourself.
	
		library addFile: file.
		self assert: (library class selectors includes: #demoTxt).
		first := library perform: #demoTxt.
		self assert: first = data.
		second := library perform: #demoTxt.
		self assert: first == second.
	] ensure: [
		library removeFile: file fileName.
		self deny: (library class selectors includes: #demoTxt).
	].! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 3/21/2008 16:12'!
testIsBinary
	self deny: (WAFileLibrary isBinary: 'scipt.js').
	self deny: (WAFileLibrary isBinary: 'markup.xml').
	self deny: (WAFileLibrary isBinary: 'markup.xhtml').
	self deny: (WAFileLibrary isBinary: 'markup.html').
	self deny: (WAFileLibrary isBinary: 'file.txt').
	self deny: (WAFileLibrary isBinary: 'calendar.ics').
	self assert: (WAFileLibrary isBinary: 'image.jpeg').
	self assert: (WAFileLibrary isBinary:  'squeak.exe')! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 9/5/2009 12:06'!
testMainJs
	| handler response |
	handler := WAFileHandler new.
	self requestContextWithUrl: '/i/dont/care/main.js'.
	self requestContext consumer next; next; next.
	response := self responseAfter: [ handler handle: self requestContext ].
	self assert: response status = 404! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'jf 10/6/2008 17:18'!
testMimeType
	| library |
	library := WATestingFiles default.
	self assert: (library mimetypeForFile: 'main.js') = 'application/x-javascript' seasideMimeType.
	self assert: (library mimetypeForFile: 'style2.css') = WAMimeType textCss.
	self assert: (library mimetypeForFile: 'image.jpg') = WAMimeType imageJpeg.
	self assert: (library mimetypeForFile: 'index') = WAMimeType applicationOctetStream! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
testNoneStatisfy
	self deny: (#(1 2 3) noneSatisfy: [ :each |
		each even ]).
	self assert: (#(1 3 5) noneSatisfy: [ :each |
		each even ])! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'pmm 9/5/2009 12:07'!
testSamplePng
	| handler library response stream contents |
	handler := WAFileHandler new.
	library := WATestingFiles default.
	self requestContextWithUrl: '/i/dont/care/WATestingFiles/sample.png'.
	requestContext consumer next; next; next.
	response := self responseAfter: [ handler handle: self requestContext ].
	self assert: response status = 200.
	self assert: response contentType = WAMimeType imagePng.
	stream := WriteStream on: ByteArray new.
	response writeContentOn: stream.
	contents := stream contents.
	self assert: contents asByteArray = (library perform: #samplePng).! !

!WAFileLibraryTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testUrlOf
	self assert: (WATestingFiles / #samplePng) greaseString = '/files/WATestingFiles/sample.png'! !

WAContextTest subclass: #WARequestHandlerTest
	instanceVariableNames: 'handler dispatcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

WARequestHandlerTest subclass: #WADispatcherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WADispatcherTest methodsFor: 'private' stamp: 'pmm 9/5/2009 12:13'!
createRequest
	^ WARequest
		method: 'GET'
		uri: '/tweets/kentbeck'! !

!WADispatcherTest methodsFor: 'private' stamp: 'jf 9/24/2009 00:01'!
newHandler
	| child |
	child := WADispatcher new.
	child
		register: WARequestHandler new at: 'foo';
		register: (WADispatcher new
					register: WARequestHandler new at: 'baz';
					yourself) at: 'bar'.
	^ child! !

!WADispatcherTest methodsFor: 'testing' stamp: 'mlucas-smith 10/2/2009 17:48'!
testCopyDispatcher
	| copy originalHandler |
	copy := handler copy.
	
	self deny: copy == handler.
	self assert: copy defaultName = handler defaultName.
	self assert: copy handlers keys = handler handlers keys.
	
	copy handlers
		do: [:each |
			originalHandler := handler handlerAt: each name.
			self assert: each class == originalHandler class.
			self deny: each == originalHandler.
			each isDispatcher
				ifTrue: [self
						assert: each handlers keys = originalHandler handlers keys]]! !

!WADispatcherTest methodsFor: 'testing' stamp: 'lr 9/29/2009 09:25'!
testEmptyPathConsumption
	| root |
	root := WADispatcher new.
	dispatcher := root register: WADispatcher new at: 'tweets'.
	handler := dispatcher register: WANextUnconsumedPathElementRequestHandler new at: 'kentbeck'.
	[ root handle: self requestContext ]
		on: WAResponseNotification
		do: [ :notification | "everything is fine" ].
	self assert: handler nextUnconsumedPathElement isNil! !

!WADispatcherTest methodsFor: 'testing' stamp: 'lr 9/29/2009 09:22'!
testPathConsumption
	dispatcher := WADispatcher new.
	handler := dispatcher register: WANextUnconsumedPathElementRequestHandler new at: 'tweets'.
	[ dispatcher handle: self requestContext ]
		on: WAResponseNotification
		do: [ :notification | "everything is fine" ].
	self assert: handler nextUnconsumedPathElement = 'kentbeck'! !

WARequestHandlerTest subclass: #WADocumentHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WADocumentHandlerTest methodsFor: 'private' stamp: 'jf 10/7/2008 00:12'!
newHandler
	^ WADocumentHandler
		document: 'body { background-color: #ffffff }'
		mimeType: WAMimeType textCss
		fileName: 'sample.css'! !

!WADocumentHandlerTest methodsFor: 'testing' stamp: 'lr 10/18/2008 17:02'!
testCopyDocumentHandler
	| copy |
	copy := handler copy.
	self assert: copy = handler.
	self deny: copy == handler.
	self assert: copy document = handler document.
	self deny: copy document == handler document.! !

WARequestHandlerTest subclass: #WAFileHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAFileHandlerTest methodsFor: 'testing' stamp: 'jf 10/6/2008 23:52'!
assertListing: aResponse
	self assert: aResponse status = 403.
	self assert: aResponse contentType main = 'text'.
	self assert: aResponse contentType sub = 'plain'! !

!WAFileHandlerTest methodsFor: 'testing' stamp: 'jf 10/6/2008 23:52'!
assertNotExisiting: aResponse
	self assert: aResponse status = 404.
	self assert: aResponse contentType main = 'text'.
	self assert: aResponse contentType sub = 'plain'! !

!WAFileHandlerTest methodsFor: 'private' stamp: 'jf 9/23/2009 23:57'!
newHandler
	^ WAFileHandler new! !

!WAFileHandlerTest methodsFor: 'testing' stamp: 'lr 1/21/2009 20:15'!
testHandleDoesNotExist
	| response |
	self requestContextWithUrl: '/root/files/Cheeseburger/'.
	response := self responseAfter: [ handler handle: self requestContext ].
	self assertNotExisiting: response.
	
	self requestContextWithUrl: '/root/files/Cheeseburger'.
	response := self responseAfter: [ handler handle: self requestContext ].
	self assertNotExisiting: response.
	
	self requestContextWithUrl: '/root/files/WAStandardFiles/cheeseburger.jpeg'.
	response := self responseAfter: [ handler handle: self requestContext ].
	self assertNotExisiting: response! !

!WAFileHandlerTest methodsFor: 'testing' stamp: 'pmm 9/5/2009 11:09'!
testHandleFileRequest
	| response |
	self requestContextWithUrl: '/root/files/WATestingFiles/sample.js'.
	self requestContext consumer next; next.
	response := self responseAfter: [ handler handle: self requestContext ].
	self assert: response status = 200.
	self assert: response contentType main = 'application'.
	self assert: response contentType sub = 'x-javascript'.
	self assert: response contents = WATestingFiles new sampleJs! !

!WAFileHandlerTest methodsFor: 'testing' stamp: 'pmm 9/5/2009 11:10'!
testHandleListing
	| response |
	self requestContextWithUrl: '/root/files/WATestingFiles/'.
	requestContext consumer next; next.
	response := self responseAfter: [ handler handle: self requestContext ].
	self assertListing: response.
	
	self requestContextWithUrl: '/root/files/WATestingFiles'.
	requestContext consumer next; next.
	response := self responseAfter: [ handler handle: self requestContext ].
	self assertListing: response.
	
	self requestContextWithUrl: '/root/files/'.
	requestContext consumer next; next.
	response := self responseAfter: [ handler handle: self requestContext ].
	self assertListing: response.
	
	self requestContextWithUrl: '/root/files'.
	requestContext consumer next; next.
	response := self responseAfter: [ handler handle: self requestContext ].
	self assertListing: response.! !

WARequestHandlerTest subclass: #WARegistryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WARegistryTest methodsFor: 'private' stamp: 'jf 9/23/2009 23:58'!
newHandler
	^ WARegistry new! !

!WARegistryTest methodsFor: 'private' stamp: 'jf 1/29/2009 21:04'!
requestContextFor: aRequest
	^ WARequestContext request: aRequest response: WABufferedResponse! !

!WARegistryTest methodsFor: 'testing' stamp: 'jf 9/27/2009 21:56'!
testCopyRegistry
	| stored key copy stored2 key2 |
	stored := WARequestHandler new.
	key := handler register: stored.

	copy := handler copy.
	
	self assert: key = (handler keyFor: stored).
	"Since registry keys are dynamically assigned, we don't expect a copy to have the same
	keys and values."
	
	stored2 := WARequestHandler new.
	key2 := handler register: stored2.
	self assert: key2 = (handler keyFor: stored2).
	self should: [ copy keyFor: stored2 ] raise: Error.
	
	copy clear.
	self assert: key = (handler keyFor: stored).! !

!WARegistryTest methodsFor: 'testing' stamp: 'jf 1/29/2009 21:05'!
testEmpty
	| context cookie |
	context := self requestContextFor: WARequest new.
	cookie := handler cookieFromContext: context ifAbsent: [ nil ].
	self assert: cookie isNil! !

!WARegistryTest methodsFor: 'testing' stamp: 'jf 7/31/2009 12:42'!
testOneOfMany
	| cookie1 cookie2 cookie3 cookie4 actual request context |
	cookie1 := WARequestCookie key: handler keyCookieName value: '1234'.
	cookie2 := (WARequestCookie key: handler keyCookieName value: '1234')
		path: '/';
		yourself.
	cookie3 := (WARequestCookie key: handler keyCookieName value: '1234')
		path: '/1/2';
		yourself.
	cookie4 := (WARequestCookie key: handler keyCookieName value: '1234')
		path: '/1/2/3';
		yourself.
	request := (WARequest method: 'GET' uri: '/1/2')
		setCookies: (Array
			with: cookie1
			with: cookie2
			with: cookie3
			with: cookie4);
		yourself.
	context := self requestContextFor: request.
	actual := handler cookieFromContext: context ifAbsent: [ nil ].
	self assert: actual == cookie3! !

!WARegistryTest methodsFor: 'testing' stamp: 'jf 7/31/2009 12:43'!
testOneOfManySlashInCookie
	| cookie1 cookie2 cookie3 cookie4 actual request context |
	cookie1 := WARequestCookie key: handler keyCookieName value: '1234'.
	cookie2 := (WARequestCookie key: handler keyCookieName value: '1234')
		path: '/';
		yourself.
	cookie3 := (WARequestCookie key: handler keyCookieName value: '1234')
		path: '/1/2/';
		yourself.
	cookie4 := (WARequestCookie key: handler keyCookieName value: '1234')
		path: '/1/2/3/';
		yourself.
	request := (WARequest method: 'GET' uri: '/1/2')
		setCookies: (Array
			with: cookie1
			with: cookie2
			with: cookie3
			with: cookie4);
		yourself.
	context := self requestContextFor: request.
	actual := handler cookieFromContext: context ifAbsent: [ nil ].
	self assert: actual == cookie3! !

!WARegistryTest methodsFor: 'testing' stamp: 'JamesFoster 9/4/2009 15:26'!
testOneOfManySlashInUrl
	| cookie1 cookie2 cookie3 cookie4 actual request context |
	cookie1 := WARequestCookie key: handler keyCookieName value: '1234'.
	cookie2 := (WARequestCookie key: handler keyCookieName value: '1234')
		path: '/';
		yourself.
	cookie3 := (WARequestCookie key: handler keyCookieName value: '1234')
		path: '/1/2';
		yourself.
	cookie4 := (WARequestCookie key: handler keyCookieName value: '1234')
		path: '/1/2/3';
		yourself.
	request := (WARequest method: 'GET' uri: '/1/2/')
		setCookies: (Array
			with: cookie1
			with: cookie2
			with: cookie3
			with: cookie4);
		yourself.
	context := self requestContextFor: request.
	actual := handler cookieFromContext: context ifAbsent: [ nil ].
	self assert: actual == cookie3! !

!WARegistryTest methodsFor: 'testing' stamp: 'jf 7/31/2009 12:44'!
testOnlyOne
	| cookie1 cookie2 request context |
	cookie1 := WARequestCookie key: handler keyCookieName value: '1234'.
	request := (WARequest method: 'GET' uri: '/')
		setCookies: (Array with: cookie1);
		yourself.
	context := self requestContextFor: request.
	cookie2 := handler cookieFromContext: context ifAbsent: [ nil ].
	self assert: cookie1 == cookie2! !

!WARegistryTest methodsFor: 'testing' stamp: 'jf 7/31/2009 12:45'!
testWrongKey
	| cookie request context actual |
	cookie := WARequestCookie key: (handler keyCookieName, '-not') value: '1234'.
	request := (WARequest method: 'GET' uri: '/')
		setCookies: (Array with: cookie);
		yourself.
	context := self requestContextFor: request.
	actual := handler cookieFromContext: context ifAbsent: [ nil ].
	self assert: actual isNil! !

!WARegistryTest methodsFor: 'testing' stamp: 'jf 7/31/2009 12:45'!
testWrongPrefix
	| cookie1 cookie2 actual request context |
	cookie1 := WARequestCookie key: handler keyCookieName value: '1234'.
	cookie2 := (WARequestCookie key: handler keyCookieName value: '1234')
		path: '/one';
		yourself.

	request := (WARequest method: 'GET' uri: '/oneo')
		setCookies: (Array
			with: cookie1
			with: cookie2);
		yourself.
	context := self requestContextFor: request.
	actual := handler cookieFromContext: context ifAbsent: [ nil ].
	self assert: actual == cookie1! !

!WARequestHandlerTest class methodsFor: 'testing' stamp: 'jf 10/7/2008 01:01'!
isAbstract
	^ self name = #WARequestHandlerTest! !

!WARequestHandlerTest methodsFor: 'private' stamp: 'jf 10/6/2008 23:13'!
newHandler
	^ WARequestHandler new! !

!WARequestHandlerTest methodsFor: 'running' stamp: 'jf 9/23/2009 23:53'!
setUp
	super setUp.
	dispatcher := WADispatcher new.
	handler := self newHandler.
	dispatcher register: handler at: 'foo'! !

!WARequestHandlerTest methodsFor: 'testing' stamp: 'lr 8/31/2008 15:46'!
testAddFilter
	| filter1 filter2 |
	filter1 := WARequestFilter new.
	filter2 := WARequestFilter new.
	self assert: (handler addFilter: filter1) = filter1.
	self assert: (handler addFilter: filter2) = filter2.
	self assert: handler filters size = 2.
	self assert: handler filters first = filter1.
	self assert: handler filters last = filter2! !

!WARequestHandlerTest methodsFor: 'testing' stamp: 'lr 11/3/2008 21:56'!
testAddFilterFirst
	| filter1 filter2 filter3 |
	filter1 := WARequestFilter new.
	filter2 := WARequestFilter new.
	filter3 := WARequestFilter new.
	self assert: (handler addFilterFirst: filter1) = filter1.
	self assert: (handler addFilterFirst: filter2) = filter2.
	self assert: (handler addFilterFirst: filter3) = filter3.
	self assert: handler filters size = 3.
	self assert: handler filters first = filter3.
	self assert: handler filters last = filter1! !

!WARequestHandlerTest methodsFor: 'testing' stamp: 'lr 11/3/2008 21:54'!
testAddFilterLast
	| filter1 filter2 filter3 |
	filter1 := WARequestFilter new.
	filter2 := WARequestFilter new.
	filter3 := WARequestFilter new.
	self assert: (handler addFilterLast: filter1) = filter1.
	self assert: (handler addFilterLast: filter2) = filter2.
	self assert: (handler addFilterLast: filter3) = filter3.
	self assert: handler filters size = 3.
	self assert: handler filters first = filter1.
	self assert: handler filters last = filter3! !

!WARequestHandlerTest methodsFor: 'testing' stamp: 'jf 9/23/2009 23:20'!
testCopyConfiguration
	| config copy |
	config := handler configuration.
	
	copy := handler copy.
	
	self assert: handler configuration == config.
	self deny: copy configuration == handler configuration.
	self deny: copy configuration isNil.! !

!WARequestHandlerTest methodsFor: 'testing' stamp: 'jf 10/7/2008 00:14'!
testCopyEmpty
	| copied |
	copied := handler copy.
	self deny: handler == copied.
	self assert: handler filter == handler.
	self assert: copied filter == copied! !

!WARequestHandlerTest methodsFor: 'testing' stamp: 'jf 10/7/2008 00:13'!
testCopyFilters
	| copied |
	handler addFilter: WARequestFilter new.
	handler addFilter: WARequestFilter new.
	copied := handler copy.
	self deny: handler == copied.
	self deny: handler filter == copied filter.
	self deny: handler filter next == copied filter next.
	self assert: handler filter handler == handler.
	self assert: copied filter handler == copied! !

!WARequestHandlerTest methodsFor: 'testing' stamp: 'jf 9/23/2009 23:19'!
testCopyParent
	| parent copy |
	parent := WADispatcher new.
	handler setParent: parent.
	
	copy := handler copy.
	
	self assert: handler parent == parent.
	self assert: copy parent isNil! !

!WARequestHandlerTest methodsFor: 'testing' stamp: 'lr 8/31/2008 15:47'!
testHandler
	| filter1 filter2 |
	filter1 := handler addFilter: WARequestFilter new.
	filter2 := handler addFilter: WARequestFilter new.
	self assert: handler handler = handler.
	self assert: filter1 handler = handler.
	self assert: filter2 handler = handler! !

!WARequestHandlerTest methodsFor: 'testing' stamp: 'lr 8/31/2008 15:45'!
testRemoveFilter
	| filter1 filter2 |
	handler addFilter: (filter1 := WARequestFilter new).
	handler addFilter: (filter2 := WARequestFilter new).
	self assert: (handler removeFilter: WARequestFilter new) isNil.
	self assert: (handler removeFilter: filter1) = filter1.
	self assert: handler filters size = 1.
	self assert: handler filters first = filter2.
	self assert: (handler removeFilter: filter2) = filter2.
	self assert: handler filters isEmpty.
	self assert: (handler removeFilter: filter2) isNil! !

!WARequestHandlerTest methodsFor: 'testing' stamp: 'jf 9/23/2009 23:40'!
testRemoveFromOldParent
	| parent parent2 |
	parent := WADispatcher new.
	parent register: handler at: 'crepe'.
	self assert: handler parent == parent.
	self assert: (parent handlers includes: handler).
	
	parent2 := WADispatcher new.
	parent2 register: handler at: 'suzette'.
	self assert: handler parent == parent2.
	self assert: (parent2 handlers includes: handler).
	self deny: (parent handlers includes: handler).! !

WAContextTest subclass: #WAUrlTest
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAUrlTest methodsFor: 'testing-parsing' stamp: 'lr 3/26/2008 21:39'!
absoluteExamples
	^ #( 'http://www.seaside.st/'
		 'http://www.seaside.st:8080/'
		 'http://lukas@www.seaside.st/'
		 'http://lukas:renggli@www.seaside.st/'
		 'http://www.seaside.st/resources'
		 'http://www.seaside.st/styles/favicon.png'
		 'http://www.seaside.st/#top'
		 'http://www.seaside.st/styles#top'
		 'http://www.seaside.st/about/screenshots?_c'
		 'http://www.seaside.st/about/screenshots?_s=XrkNBpErXTKlVRhn'
		 'http://www.seaside.st/about/screenshots?_s=XrkNBpErXTKlVRhn&_k=lZWXfESZ'
		 'http://www.seaside.st/about/screenshots?_s=XrkNBpErXTKlVRhn&_k=lZWXfESZ&_n&47'
		 'http://www.seaside.st/about/screenshots?_s=XrkNBpErXTKlVRhn&_k=lZWXfESZ&_n&47#149361951'
		 'http://lukas:renggli@www.seaside.st/about/screenshots?_s=XrkNBpErXTKlVRhn&_k=lZWXfESZ&_n&47#149361951'
		 'http://lukas:renggli@www.seaside.st:8080/about/screenshots?_s=XrkNBpErXTKlVRhn&_k=lZWXfESZ&_n&47#149361951' )! !

!WAUrlTest methodsFor: 'testing-parsing' stamp: 'lr 3/27/2008 08:28'!
ambigousExamples
	"These examples consist of many edge cases that are sometimes not quite legal. The test assures that they no error is thrown and that they parse to something meaningful anyway."
	
	^ #( "scheme"
		 ( 'www.seaside.st' '/www.seaside.st' )
		 ( 'http://www.seaside.st:443/' 'http://www.seaside.st:443/' )
		 ( 'https://www.seaside.st:80/' 'https://www.seaside.st:80/' )
		
		 "port"
		 ( 'http://www.seaside.st:/' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st:8x/' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st:x8/' 'http://www.seaside.st/' )
		
		 "host"
		 ( 'http://' '/' )
		 ( 'http://@' 'http://%40/' )
		
		 "username, password"
		 ( 'http://@www.seaside.st/' 'http://%40www.seaside.st/' )
		 ( 'http://:lukas@www.seaside.st/' 'http://:lukas@www.seaside.st/' )
		 ( 'http://lukas:@www.seaside.st/' 'http://lukas:@www.seaside.st/' )
		
		 "path"
		 ( 'http://www.seaside.st' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st//' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st/.' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st/./' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st/..' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st/../' 'http://www.seaside.st/' )
		
		 "query"
		 ( 'http://www.seaside.st/?' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st/??' 'http://www.seaside.st/?%3F' )
		 ( 'http://www.seaside.st/?=2' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st/?&' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st/?1==' 'http://www.seaside.st/?1=%3D' )
		 ( 'http://www.seaside.st/?1=2&' 'http://www.seaside.st/?1=2' )
		 
		
		 "fragment"
		 ( 'http://www.seaside.st/#' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st/##' 'http://www.seaside.st/#%23' )
		 ( 'http://www.seaside.st/#?a=b' 'http://www.seaside.st/#%3Fa%3Db' ) )! !

!WAUrlTest methodsFor: 'utitlies' stamp: 'lr 7/16/2009 09:49'!
asString: aCollectionOfIntegers
	^ String streamContents: [ :stream |
		aCollectionOfIntegers do: [ :each |
			stream nextPut: (Character codePoint: each) ] ]! !

!WAUrlTest methodsFor: 'testing-parsing' stamp: 'lr 5/31/2008 19:08'!
equalExamples
	"These examples about URI equivalence come from Sam Ruby and are quite hardcore. Java and Perl fail them, C# passes them.
	http://intertwingly.net/blog/2004/07/31/URI-Equivalence"
	
	^ #( 
		 ( 'http://example.com/'				'http://example.com' )
		 ( 'http://example.com/' 				'HTTP://example.com/' )
		 ( 'http://example.com/' 				'http://example.com:/' )
		 ( 'http://example.com/' 				'http://example.com:80/' )
		 ( 'http://example.com/' 				'http://Example.com/' )
		 ( 'http://example.com/~smith/'		'http://example.com/%7Esmith/' )
		 ( 'http://example.com/~smith/'		'http://example.com/%7esmith/' )
		 ( 'http://example.com/%7Esmith/'	'http://example.com/%7esmith/' )
			
		"The following example requires Unicode normalization, something that no Smalltalk implmentation is able to perform.
		 ( 'http://example.com/%C3%87'		'http://example.com/C%CC%A7' )" )! !

!WAUrlTest methodsFor: 'testing-parsing' stamp: 'lr 3/26/2008 22:15'!
relativeExamples
	^ #( ( 'http://www.seaside.st/foo' '' 'http://www.seaside.st/foo' )
		 ( 'http://www.seaside.st/foo' '.' 'http://www.seaside.st/foo' )
		 ( 'http://www.seaside.st/foo' './bar' 'http://www.seaside.st/foo/bar' )
		 ( 'http://www.seaside.st/foo' 'bar' 'http://www.seaside.st/foo/bar' )
		 ( 'http://www.seaside.st/foo' 'bar/.' 'http://www.seaside.st/foo/bar' )
		 ( 'http://www.seaside.st/foo' 'bar/..' 'http://www.seaside.st/foo' )
		 ( 'http://www.seaside.st/foo' 'bar/../..' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st/foo' 'bar/../../..' 'http://www.seaside.st/' )

		 ( 'http://www.seaside.st/foo' '/' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st/foo' '/.' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st/foo' '/./bar' 'http://www.seaside.st/bar' )
		 ( 'http://www.seaside.st/foo' '/bar' 'http://www.seaside.st/bar' )
		 ( 'http://www.seaside.st/foo' '/bar/.' 'http://www.seaside.st/bar' )
		 ( 'http://www.seaside.st/foo' '/bar/..' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st/foo' '/bar/../..' 'http://www.seaside.st/' )
		 ( 'http://www.seaside.st/foo' '/bar/../../..' 'http://www.seaside.st/' ) )! !

!WAUrlTest methodsFor: 'running' stamp: 'lr 8/17/2007 21:05'!
setUp
	url := WAUrl new! !

!WAUrlTest methodsFor: 'testing-adding' stamp: 'jf 9/30/2009 01:10'!
testAddAllToPath
	url addAllToPath: #('files' 'WAStandardFiles' 'seaside.jpg' ).
	self assert: url path size = 3.
	self assert: url path first = 'files'.
	self assert: url path last = 'seaside.jpg'.
	self assert: url greaseString = '/files/WAStandardFiles/seaside.jpg'! !

!WAUrlTest methodsFor: 'testing-adding' stamp: 'jf 9/30/2009 01:10'!
testAddParameter
	url addParameter: 'x'.
	self assert: url greaseString = '/?x'.
	url addParameter: 'y'.
	self assert: url greaseString = '/?x&y'.
	url addParameter: 'x'.
	self assert: url greaseString = '/?x&y&x'! !

!WAUrlTest methodsFor: 'testing-adding' stamp: 'jf 9/30/2009 01:10'!
testAddParameterValue
	url 
		addParameter: 'x'
		value: 1.
	self assert: url greaseString = '/?x=1'.
	url 
		addParameter: 'y'
		value: 2.
	self assert: url greaseString = '/?x=1&y=2'.
	url 
		addParameter: 'x'
		value: 3.
	self assert: url greaseString = '/?x=1&y=2&x=3'! !

!WAUrlTest methodsFor: 'testing-adding' stamp: 'jf 9/30/2009 01:10'!
testAddToPath
	url addToPath: '/files/WAStandardFiles/seaside.jpg'.
	self assert: url path size = 3.
	self assert: url path first = 'files'.
	self assert: url path second = 'WAStandardFiles'.
	self assert: url path third = 'seaside.jpg'.
	self assert: url greaseString = '/files/WAStandardFiles/seaside.jpg'! !

!WAUrlTest methodsFor: 'testing-adding' stamp: 'jf 9/30/2009 01:10'!
testAddToPathWithSlash
	url addToPath: '/files/WAStandardFiles/'.
	self assert: url path size = 2.
	self assert: url path first = 'files'.
	self assert: url path second = 'WAStandardFiles'.
	self assert: url greaseString = '/files/WAStandardFiles/'! !

!WAUrlTest methodsFor: 'testing' stamp: 'jf 9/22/2008 14:11'!
testConversion
	| converted |
	url
		hostname: 'example.com';
		addToPath: 'foo';
		addToPath: 'bar'.
	
	converted := 'http://example.com/foo/bar' seasideUrl.
	
	self assert: (converted isKindOf: WAUrl).
	self assert: url = converted.! !

!WAUrlTest methodsFor: 'testing-encoding' stamp: 'jf 9/30/2009 00:27'!
testDecodedWith
	"http://ser:pa@localhost:8080/foo/bc/df?=stgetc&#trget"
	| pathArray expectedPathArray |
	url := (WAUrl absolute: 'http://%c3%b9ser:pa%c3%9f@localhost:8080/foo/%C3%A4bc/d%c3%aaf?%c3%b5=st%c3%aegetc&%c3%b4#t%c3%a5rget') decodedWith: (GRCodec forEncoding: 'utf-8').
	self assert: url scheme = 'http'.
	self assert: url username = (self asString: #(249 115 101 114 )).
	self assert: url password = (self asString: #(112 97 223 )).
	self assert: url hostname = 'localhost'.
	self assert: url port = 8080.
	pathArray := url path asArray.
	self assert: pathArray size = 3.
	"must not use Collection >> #= due to Enterprise Smalltalk (tm)"
	expectedPathArray := Array 
		with: 'foo'
		with: (self asString: #(228 98 99 ))
		with: (self asString: #(100 234 102 )).
	expectedPathArray keysAndValuesDo: [ :index :each | self assert: (pathArray at: index) = each ].
	self assert: url parameters size = 2.
	self assert: (url parameters at: (self asString: #(245 ))) = (self asString: #(
					115
					116
					238
					103
					101
					116
					99
				)).
	self assert: (url parameters includesKey: (self asString: #(244 ))).
	self assert: (url parameters at: (self asString: #(244 ))) isNil.
	""
	self assert: url fragment = (self asString: #(116 229 114 103 101 116 ))! !

!WAUrlTest methodsFor: 'testing-comparing' stamp: 'lr 2/12/2008 11:15'!
testEqual
	url hostname: 'seaside.st'; addParameter: 'foo' value: 'bar'. 
	self assert: url = url.
	self deny: url = WAUrl new.
	self deny: url = url printString.
	self deny: url = (url withoutParameters).
	self deny: url = (url withParameter: 'zork').
	self deny: url = (url withParameter: 'zork' value: 'zonk')! !

!WAUrlTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testFragment
	url fragment: 'id'.
	self assert: url fragment = 'id'.
	self assert: url greaseString = '/#id'! !

!WAUrlTest methodsFor: 'testing-comparing' stamp: 'lr 2/12/2008 11:13'!
testHash
	url hostname: 'seaside.st'.
	self assert: url hash = url hash.
	self assert: url hash = url copy hash! !

!WAUrlTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testHostname
	url hostname: 'seaside.st'.
	self assert: url hostname = 'seaside.st'.
	self assert: url greaseString = 'http://seaside.st/'! !

!WAUrlTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testParameters
	url parameters 
		at: '1'
		put: nil.
	self assert: url greaseString = '/?1'.
	url parameters 
		at: '2'
		put: 'foo'.
	self assert: url greaseString = '/?1&2=foo'.
	url parameters 
		at: '3'
		put: 123.
	self assert: url greaseString = '/?1&2=foo&3=123'.
	url parameters 
		at: '4'
		put: 'foo bar&zork'.
	self assert: url greaseString = '/?1&2=foo&3=123&4=foo%20bar%26zork'! !

!WAUrlTest methodsFor: 'testing-parsing' stamp: 'jf 9/30/2009 01:10'!
testParseAbsolute
	self absoluteExamples do: 
		[ :each | 
		self 
			assert: (WAUrl absolute: each) greaseString = each
			description: each
			resumable: true ]! !

!WAUrlTest methodsFor: 'testing-parsing' stamp: 'jf 9/30/2009 01:10'!
testParseAmbigous
	self ambigousExamples do: 
		[ :each | 
		self 
			assert: (WAUrl absolute: each first) greaseString = each last
			description: each last
			resumable: true ]! !

!WAUrlTest methodsFor: 'testing-parsing' stamp: 'pmm 3/28/2008 22:17'!
testParseEqual
	self equalExamples do: [ :each |
		self 
			assert: (WAUrl absolute: each first) = (WAUrl absolute: each second)
		 	description: each second resumable: true ]! !

!WAUrlTest methodsFor: 'testing-parsing' stamp: 'jf 9/30/2009 01:10'!
testParseRelative
	self relativeExamples do: 
		[ :each | 
		self 
			assert: (WAUrl 
				absolute: each first
				relative: each second) greaseString = each last
			description: each last
			resumable: true ]! !

!WAUrlTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testPassword
	url
		hostname: 'seaside.st';
		username: 'foo';
		password: 'bar'.
	self assert: url password = 'bar'.
	self assert: url greaseString = 'http://foo:bar@seaside.st/'! !

!WAUrlTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testPath
	self assert: url greaseString = '/'.
	url path add: 'aa'.
	self assert: url greaseString = '/aa'.
	url path add: 'bb'.
	self assert: url greaseString = '/aa/bb'.
	self assert: url path asArray = #('aa' 'bb' )! !

!WAUrlTest methodsFor: 'testing-encoding' stamp: 'lr 10/18/2008 12:16'!
testPathEncoding
	url path: #( 'foo/bar' ).
	self assert: url printString = '/foo%2Fbar'.

	url path: #( 'foo bar' ).
	self assert: url printString = '/foo%20bar'.

	url path: #( 'foo+bar' ).
	self assert: url printString = '/foo%2Bbar'.

	url path: #( 'foo%bar' ).
	self assert: url printString = '/foo%25bar'! !

!WAUrlTest methodsFor: 'testing-encoding' stamp: 'pmm 3/22/2008 19:58'!
testPathString
	self assert: url pathString = '/'.

	url path: #( 'foo' 'bar' ).
	self assert: url pathString = '/foo/bar'.! !

!WAUrlTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testPort
	url
		hostname: 'seaside.st';
		port: 8080.
	self assert: url port = 8080.
	self assert: url greaseString = 'http://seaside.st:8080/'! !

!WAUrlTest methodsFor: 'testing-encoding' stamp: 'lr 10/18/2008 12:16'!
testQueryEncoding
	self
		assert: (url withParameter: '/' value: ' ')
			printString = '/?%2F=%20'.
	self
		assert: (url withParameter: '+' value: '%')
			printString = '/?%2B=%25'.
	self
		assert: (url withParameter: '?' value: '&')
			printString = '/?%3F=%26'.
	self
		assert: (url withParameter: '[' value: ']')
			printString = '/?%5B=%5D'.
	self
		assert: (url withParameter: '=' value: '<')
			printString = '/?%3D=%3C'! !

!WAUrlTest methodsFor: 'testing-encoding' stamp: 'pmm 4/21/2008 21:27'!
testRelativeTo
	| first second relativePath |
	first := WAUrl absolute: 'http://www.seaside.st/news'.
	second := WAUrl absolute: 'http://www.seaside.st/news/2008/April'.
	relativePath := first relativeTo: second.
	"we can not use #= here because of the Smalltalk that makes the easy parts more fucking tedious than Java"
	self assert: relativePath size = 2.
	self assert: relativePath first = '2008'.
	self assert: relativePath second = 'April'.! !

!WAUrlTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testScheme
	url
		scheme: 'https';
		hostname: 'seaside.st'.
	self assert: url scheme = 'https'.
	self assert: url greaseString = 'https://seaside.st/'.
	"Tests from Boris"
	url hostname: 'seaside.st'.
	url
		port: 80;
		scheme: 'http'.
	self assert: url greaseString = 'http://seaside.st/'.
	url
		port: 443;
		scheme: 'https'.
	self assert: url greaseString = 'https://seaside.st/'.
	url
		port: 80;
		scheme: #http.
	self assert: url greaseString = 'http://seaside.st/'.
	url
		port: 443;
		scheme: #https.
	self assert: url greaseString = 'https://seaside.st/'! !

!WAUrlTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testSlash
	url hostname: 'seaside.st'.
	self assert: (url
			slash: true;
			greaseString) = 'http://seaside.st/'.
	self assert: (url
			slash: false;
			greaseString) = 'http://seaside.st/'.
	url addToPath: 'foo'.
	self assert: (url
			slash: true;
			greaseString) = 'http://seaside.st/foo/'.
	self assert: (url
			slash: false;
			greaseString) = 'http://seaside.st/foo'! !

!WAUrlTest methodsFor: 'testing' stamp: 'lr 8/11/2009 10:04'!
testTakeServerParametersFromRequest
	| request |
	request := WARequest new
		setHeaders: (Dictionary new
			at: 'host' put: 'www.seaside.st:8080';
			yourself);
		yourself.
	url takeServerParametersFromRequest: request.
	self assert: url printString = 'http://www.seaside.st:8080/'! !

!WAUrlTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testTakeServerParametersFromRequestBase
	| request |
	request := (WARequest 
		method: 'GET'
		uri: (WAUrl new
				scheme: 'https';
				yourself))
		setHeaders: (Dictionary new
				at: 'host'
					put: 'www.thehost.com:1337';
				yourself);
		yourself.
	url takeServerParametersFromRequest: request.
	self assert: url greaseString = 'https://www.thehost.com:1337/'! !

!WAUrlTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testTakeServerParametersFromRequestHttps
	| request |
	request := WARequest new
		setHeaders: (Dictionary new
				at: 'host'
					put: 'www.seaside.st';
				at: 'base'
					put: 'foo/bar';
				yourself);
		yourself.
	url takeServerParametersFromRequest: request.
	self assert: url greaseString = 'http://www.seaside.st/foo/bar'! !

!WAUrlTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testUsername
	url
		hostname: 'seaside.st';
		username: 'foo'.
	self assert: url username = 'foo'.
	self assert: url greaseString = 'http://foo@seaside.st/'! !

TestCase subclass: #WACookieTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WACookieTest methodsFor: 'testing' stamp: 'lr 11/17/2008 20:36'!
testCombine
	| expiry actual cookie1 cookie2 |
	expiry := DateAndTime year: 2007 month: 11 day: 21 hour: 14 minute: 42 second: 48 offset: (Duration days: 0 hours: 2 minutes: 0 seconds: 0).
	cookie1 := WACookie key: 'ikuser' value: '1234'.
	cookie1 expiry: expiry.

	cookie2 := WACookie key: 'JSESSIONID' value: '8543783483494373483764'.
	
	actual := WACookie
		combine: (Array with: cookie1 with: cookie2)
		using: [ :each | each oldNetscapeString ].

	self assert: actual = 'ikuser=1234; expires=Wed, 21-Nov-2007 12:42:48 GMT, JSESSIONID=8543783483494373483764'! !

!WACookieTest methodsFor: 'testing' stamp: 'pmm 4/5/2008 15:21'!
testCopy
	| original copy |
	original := (WACookie key: 'meta' value: 'phor')
		ports: #(80) asOrderedCollection;
		yourself.
		
	copy := original copy.
	copy ports at: 1 put: 443.
		
	self assert: original ports size = 1.
	self assert: original ports first = 80.
	
	self assert: copy ports size = 1.
	self assert: copy ports first = 443.! !

!WACookieTest methodsFor: 'testing' stamp: 'pmm 3/22/2008 15:59'!
testEquals
	| cookie1 cookie2 |
	cookie1 := WARequestCookie key: 'JSESSIONID' value: '8543783483494373483764'.
	cookie2 := WARequestCookie key: 'JSESSIONID' value: '8543783483494373483767'.
	
	self assert: cookie1 = cookie2.
	self assert: cookie2 = cookie1.
	self assert: cookie1 hash = cookie2 hash.
	
	cookie2 domain: 'www.example.com'.
	self deny: cookie1 = cookie2.
	self deny: cookie2 = cookie1.
	self deny: cookie1 hash = cookie2 hash.

	cookie1 domain: 'www.example.com'.
	self assert: cookie1 = cookie2.
	self assert: cookie2 = cookie1.
	self assert: cookie1 hash = cookie2 hash.
	
	cookie1 path: '/cgi-bin/index.cbl'.
	self deny: cookie1 = cookie2.
	self deny: cookie2 = cookie1.
	self deny: cookie1 hash = cookie2 hash.
	
	cookie2 path: '/cgi-bin/index.cbl'.
	self assert: cookie1 = cookie2.
	self assert: cookie2 = cookie1.
	self assert: cookie1 hash = cookie2 hash.
	
	cookie1 ports: #(8080).
	self assert: cookie1 = cookie2.
	self assert: cookie2 = cookie1.
	self assert: cookie1 hash = cookie2 hash.
	
	cookie2 ports: #(9090).
	self assert: cookie1 = cookie2.
	self assert: cookie2 = cookie1.
	self assert: cookie1 hash = cookie2 hash.! !

!WACookieTest methodsFor: 'testing' stamp: 'pmm 4/5/2008 15:42'!
testExpireInPast
	| cookie |
	cookie := (WACookie key: 'unit' value: 'testing').
	cookie expireInPast.
	self assert: cookie expiry < DateAndTime now asUTC.
	self assert: cookie expiry >= (DateAndTime year: 1970 day: 1 hour: 0 minute: 0 second: 0) asUTC.
	self assert: cookie maxAge = 0! !

!WACookieTest methodsFor: 'testing' stamp: 'jgf 1/21/2009 11:45'!
testExpirePrinting
	| cookie |
	cookie := WACookie key: 'foo' value: 'bar'.
	cookie expiry: (DateAndTime year: 2003 day: 4 hour: 5 minute: 6 second: 7 offset: Duration zero).
	self assert: cookie oldNetscapeString = 'foo=bar; expires=Sat, 04-Jan-2003 05:06:07 GMT'! !

!WACookieTest methodsFor: 'testing' stamp: 'pmm 3/22/2008 13:48'!
testFromStringOldNetscape
	| cookies customer partNumber shipping |
	cookies := WACookie fromString: 'Customer=WILE_E_COYOTE;
                 Part_Number=Rocket_Launcher_0001;
                 Shipping=FedEx'.
	self assert: cookies size = 3.
	
	customer := cookies detect: [ :each | each key = 'Customer' ].
	self assert: customer value = 'WILE_E_COYOTE'.
	
	partNumber := cookies detect: [ :each | each key = 'Part_Number' ].
	self assert: partNumber value = 'Rocket_Launcher_0001'.
	
	shipping := cookies detect: [ :each | each key = 'Shipping' ].
	self assert: shipping value = 'FedEx'.! !

!WACookieTest methodsFor: 'testing' stamp: 'pmm 3/22/2008 13:57'!
testFromStringRfc2965
	| cookies customer partNumber shipping |
	cookies := WARequestCookie fromString: '$Version="1";
                 Customer="WILE_E_COYOTE"; $Path="/acme"; $Port="1"; $Domain="www.1.com";
                 Part_Number="Rocket_Launcher_0001"; $Path="/acme/rockes"; $Port="2,3"; $Domain="www.2.com";
                 Shipping="FedEx"'.
	self assert: cookies size = 3.
	
	customer := cookies detect: [ :each | each key = 'Customer' ].
	self assert: customer version = 1.
	self assert: customer value = 'WILE_E_COYOTE'.
	self assert: customer path = '/acme'.
	self assert: customer domain = 'www.1.com'.
	self assert: customer ports size = 1.
	self assert: customer ports first = 1.
	
	partNumber := cookies detect: [ :each | each key = 'Part_Number' ].
	self assert: partNumber version = 1.
	self assert: partNumber value = 'Rocket_Launcher_0001'.
	self assert: partNumber path = '/acme/rockes'.
	self assert: partNumber domain = 'www.2.com'.
	self assert: partNumber ports size = 2.
	self assert: partNumber ports first = 2.
	self assert: partNumber ports second = 3.
	
	shipping := cookies detect: [ :each | each key = 'Shipping' ].
	self assert: shipping version = 1.
	self assert: shipping value = 'FedEx'.
	self assert: shipping path = '/'.
	self assert: shipping domain isNil.
	self assert: shipping ports isNil.! !

!WACookieTest methodsFor: 'testing' stamp: 'lr 11/17/2008 20:36'!
testWriteOn
	| expiry cookie |
	expiry := DateAndTime year: 2007 month: 11 day: 21 hour: 14 minute: 42 second: 48 offset: (Duration days: 0 hours: 2 minutes: 0 seconds: 0).
	cookie := WACookie key: 'ikuser' value: '1234'.
	self assert: cookie oldNetscapeString = 'ikuser=1234'.
	self assert: cookie rfc2109String = 'ikuser="1234"; Version=1'.
	self assert: cookie rfc2965String = 'ikuser="1234"; Version=1'.
	
	cookie expiry: expiry.
	cookie maxAge: 3600.
	self assert: cookie oldNetscapeString = 'ikuser=1234; expires=Wed, 21-Nov-2007 12:42:48 GMT'.
	self assert: cookie oldNetscapeStringWithoutKey = '1234; expires=Wed, 21-Nov-2007 12:42:48 GMT'.
	self assert: cookie rfc2109String = 'ikuser="1234"; Max-Age="3600"; Version=1'.
	self assert: cookie rfc2965String = 'ikuser="1234"; Max-Age="3600"; Version=1'.
	
	cookie path: '/seaside/counter'.
	self assert: cookie oldNetscapeString = 'ikuser=1234; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter'.
	self assert: cookie oldNetscapeStringWithoutKey = '1234; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter'.
	self assert: cookie rfc2109String = 'ikuser="1234"; Max-Age="3600"; path="/seaside/counter"; Version=1'.
	self assert: cookie rfc2965String = 'ikuser="1234"; Max-Age="3600"; path="/seaside/counter"; Version=1'.
	
	cookie value: nil.
	self assert: cookie oldNetscapeString = 'ikuser=; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter'.
	self assert: cookie oldNetscapeStringWithoutKey = '; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter'.
	self assert: cookie rfc2109String = 'ikuser=""; Max-Age="3600"; path="/seaside/counter"; Version=1'.
	self assert: cookie rfc2965String = 'ikuser=""; Max-Age="3600"; path="/seaside/counter"; Version=1'.
	
	cookie value: '1234'.
	cookie domain: 'www.example.com'.
	cookie ports: (Array with: 80 with: 433).
	self assert: cookie oldNetscapeString = 'ikuser=1234; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter; domain=www.example.com'.
	self assert: cookie oldNetscapeStringWithoutKey = '1234; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter; domain=www.example.com'.
	self assert: cookie rfc2109String = 'ikuser="1234"; Max-Age="3600"; path="/seaside/counter"; domain="www.example.com"; Version=1'.
	self assert: cookie rfc2965String = 'ikuser="1234"; Max-Age="3600"; path="/seaside/counter"; Port="80,433"; domain="www.example.com"; Version=1'.
	
	cookie discard: true.
	cookie secure: true.
	cookie httpOnly: true.
	self assert: cookie oldNetscapeString = 'ikuser=1234; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter; domain=www.example.com; Secure; HttpOnly'.
	self assert: cookie oldNetscapeStringWithoutKey = '1234; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter; domain=www.example.com; Secure; HttpOnly'.
	self assert: cookie rfc2109String = 'ikuser="1234"; Max-Age="3600"; path="/seaside/counter"; domain="www.example.com"; Secure; HttpOnly; Version=1'.
	self assert: cookie rfc2965String = 'ikuser="1234"; Max-Age="3600"; path="/seaside/counter"; Port="80,433"; domain="www.example.com"; Secure; HttpOnly; Discard; Version=1'.
	
	cookie comment: 'FIS Heer username'.
	cookie commentUrl: 'http://www.example.com/session-cookie.html'.
	self assert: cookie oldNetscapeString = 'ikuser=1234; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter; domain=www.example.com; Secure; HttpOnly'.
	self assert: cookie oldNetscapeStringWithoutKey = '1234; expires=Wed, 21-Nov-2007 12:42:48 GMT; path=/seaside/counter; domain=www.example.com; Secure; HttpOnly'.
	self assert: cookie rfc2109String = 'ikuser="1234"; Comment="FIS Heer username"; Max-Age="3600"; path="/seaside/counter"; domain="www.example.com"; Secure; HttpOnly; Version=1'.
	self assert: cookie rfc2965String = 'ikuser="1234"; Comment="FIS Heer username"; CommentURL="http://www.example.com/session-cookie.html"; Max-Age="3600"; path="/seaside/counter"; Port="80,433"; domain="www.example.com"; Secure; HttpOnly; Discard; Version=1'.! !

TestCase subclass: #WACurrentRequestContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WACurrentRequestContextTest methodsFor: 'testing' stamp: 'jf 2/3/2009 14:53'!
testWithoutValue
	self should: [ WACurrentRequestContext value ] raise: WARequestContextNotFound! !

!WACurrentRequestContextTest methodsFor: 'testing' stamp: 'jf 2/3/2009 14:52'!
testWithValue
	WACurrentRequestContext
		use: 1
		during: [ self assert: WACurrentRequestContext value = 1 ]! !

TestCase subclass: #WADictionaryMergerTest
	instanceVariableNames: 'merger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WADictionaryMergerTest methodsFor: 'running' stamp: 'pmm 9/4/2008 14:14'!
setUp
	super setUp.
	merger := WADictionaryMerger new! !

!WADictionaryMergerTest methodsFor: 'testing' stamp: 'pmm 9/4/2008 14:19'!
testMultiplePut
	| dictionary value |
	merger at: 'key' put: 'value'.
	merger at: 'key' put: 'value2'.
	merger at: 'key' put: #('value3' 'value4') asOrderedCollection.
	dictionary := merger dictionary.
	self assert: dictionary size = 1.
	value := dictionary at: 'key'.
	self assert: (value isKindOf: OrderedCollection).
	self assert: value size = 4.
	self assert: value first = 'value'.
	self assert: value second = 'value2'.
	self assert: value third = 'value3'.
	self assert: value fourth = 'value4'.! !

!WADictionaryMergerTest methodsFor: 'testing' stamp: 'pmm 9/4/2008 14:20'!
testPutOrderedCollection
	| dictionary |
	merger at: 'key' put: #('value') asOrderedCollection.
	dictionary := merger dictionary.
	self assert: dictionary size = 1.
	self assert: (dictionary at: 'key') = 'value'.! !

!WADictionaryMergerTest methodsFor: 'testing' stamp: 'pmm 9/4/2008 14:16'!
testSingleMapping
	| dictionary |
	merger at: 'key' put: 'value'.
	merger at: 'key2' put: 'value2'.
	dictionary := merger dictionary.
	self assert: dictionary size = 2.
	self assert: (dictionary at: 'key') = 'value'.
	self assert: (dictionary at: 'key2') = 'value2'.! !

TestCase subclass: #WADynamicVariableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WADynamicVariableTest methodsFor: 'testing' stamp: 'lr 3/29/2008 22:05'!
testAnswer
	self assert: (WADynamicVariable use: 'value' during: [ true ])! !

!WADynamicVariableTest methodsFor: 'testing' stamp: 'lr 3/29/2008 21:56'!
testWithNestedValue
	WADynamicVariable 
		use: 'outer' 
		during: [
			WADynamicVariable 
				use: 'inner'
				during: [ self assert: WADynamicVariable value = 'inner' ].
			self assert: WADynamicVariable value = 'outer' ]! !

!WADynamicVariableTest methodsFor: 'testing' stamp: 'lr 3/29/2008 21:56'!
testWithoutValue
	self assert: WADynamicVariable value isNil! !

!WADynamicVariableTest methodsFor: 'testing' stamp: 'lr 3/29/2008 21:56'!
testWithValue
	WADynamicVariable 
		use: 'value' 
		during: [ self assert: WADynamicVariable value = 'value' ]! !

TestCase subclass: #WAExceptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

WAExceptionHandlerTest subclass: #WAErrorHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAErrorHandlerTest class methodsFor: 'testing' stamp: 'jf 12/30/2008 19:37'!
shouldInheritSelectors
	^ true! !

!WAErrorHandlerTest methodsFor: 'accessing' stamp: 'jf 12/29/2008 17:32'!
handlerClass
	^ WAErrorHandler! !

!WAErrorHandlerTest methodsFor: 'testing' stamp: 'jf 1/23/2009 16:11'!
testError
	| context |
	context := self createRequestContext.
	[ self handlerClass
		handleExceptionsDuring: [ WAError signal ]
		context: context ]
			on: WAResponseNotification
			do: [ :n | self assert: context response status = 500. ^ self ].
			
	self assert: false! !

!WAErrorHandlerTest methodsFor: 'testing' stamp: 'jf 1/1/2009 15:17'!
testHandlesError
	self assert: (self handlerClass handles: Error new).
	self assert: (self createHandler handles: Error new)! !

!WAErrorHandlerTest methodsFor: 'testing' stamp: 'jf 1/1/2009 15:17'!
testHandlesWarning
	self assert: (self handlerClass handles: Warning new).
	self assert: (self createHandler handles: Warning new)! !

!WAErrorHandlerTest methodsFor: 'testing' stamp: 'jf 1/23/2009 16:11'!
testWarning
	| context |
	context := self createRequestContext.
	[ self handlerClass
		handleExceptionsDuring: [ Warning signal ]
		context: context ]
			on: WAResponseNotification
			do: [ :n | self assert: context response status = 500. ^ self ].
			
	self assert: false! !

!WAExceptionHandlerTest methodsFor: 'testing' stamp: 'jf 12/29/2008 16:43'!
assertHandles: anObject
	self assertHandles: anObject returnsSatisfying: [:result | result]! !

!WAExceptionHandlerTest methodsFor: 'testing' stamp: 'jf 1/1/2009 15:18'!
assertHandles: anObject returnsSatisfying: aBlock 
	| result instanceResult |
	result := self handlerClass handles: anObject.
	instanceResult := self createHandler handles: anObject.
	self assert: result = instanceResult.
	self assert: (aBlock value: result)! !

!WAExceptionHandlerTest methodsFor: 'accessing' stamp: 'jf 1/21/2009 11:16'!
createHandler
	^ self handlerClass context: self createRequestContext! !

!WAExceptionHandlerTest methodsFor: 'accessing' stamp: 'jf 7/31/2009 09:38'!
createRequestContext
	^ WARequestContext request: WARequest new response: WABufferedResponse new! !

!WAExceptionHandlerTest methodsFor: 'accessing' stamp: 'jf 12/30/2008 20:09'!
handlerClass
	"The handler to test in this test case"
	^ WAExceptionHandler! !

!WAExceptionHandlerTest methodsFor: 'testing' stamp: 'jf 1/1/2009 15:18'!
testCommaReturnsExceptionSet
	| set |
	set := self handlerClass, WATestError.
	self assert: (set isKindOf: ExceptionSet).
	self assert: (set handles: WATestError new).
	
	set := self createHandler, WATestError.
	self assert: (set isKindOf: ExceptionSet).
	self assert: (set handles: WATestError new)! !

!WAExceptionHandlerTest methodsFor: 'testing' stamp: 'pmm 1/10/2009 14:42'!
testHandlerClassValidExceptionSelector
	"The ANSI standard specifies that an object must implement #handles: and #, in
	order to be used as an 'exception selector' (that is, as the first paramter to #on:do:).
	However, some platforms seem to require other protocol. This test will make sure
	that each platform has implemented what is required to make this work."
	
	[[ self unhandledExceptionClass signal ]
		on: self handlerClass
		do: [ :exception | self assert: false ]]
			on: Exception
			do: [ :exception | ^ self "test passed" ].
		
	self assert: false "The method should have returned already"! !

!WAExceptionHandlerTest methodsFor: 'testing' stamp: 'pmm 1/10/2009 14:42'!
testHandlerInstanceValidExceptionSelector
	"The ANSI standard specifies that an object must implement #handles: and #, in
	order to be used as an 'exception selector' (that is, as the first paramter to #on:do:).
	However, some platforms seem to require other protocol. This test will make sure
	that each platform has implemented what is required to make this work."
	
	[[ self unhandledExceptionClass signal ]
		on: self createHandler
		do: [ :exception | self assert: false ]]
			on: Exception
			do: [ :exception | ^ self "test passed" ].
		
	self assert: false "The method should have returned already"! !

!WAExceptionHandlerTest methodsFor: 'testing' stamp: 'mlucas-smith 6/15/2009 21:20'!
testHandlesReturnsBool
	self 
		assertHandles: WATestError new
		returnsSatisfying: [ :result | result == true or: [ result == false ] ]! !

!WAExceptionHandlerTest methodsFor: 'testing' stamp: 'jok 1/26/2009 15:44'!
testInternalError
	| context |
	context := self createRequestContext.
	[ self handlerClass
			internalError: (WATestError new)
			context: context ]
		on: WAResponseNotification
		do: [ :n |
			self assert: (context response isKindOf: WAResponse).
			self assert: context response status = 500.
			^ self ].
		
	self assert: false! !

!WAExceptionHandlerTest methodsFor: 'testing' stamp: 'jok 1/26/2009 15:44'!
testInternalErrorWithMessage
	| context |
	context := self createRequestContext.
	[ self handlerClass
			internalError: (WATestError new messageText: 'test'; yourself)
			context: context ]
		on: WAResponseNotification
		do: [ :n |
			self assert: (context response isKindOf: WAResponse).
			self assert: context response status = 500.
			^ self ].
		
	self assert: false! !

!WAExceptionHandlerTest methodsFor: 'testing' stamp: 'pmm 1/10/2009 14:43'!
testUnhandledException
	[ self handlerClass
		handleExceptionsDuring: [ self unhandledExceptionClass signal ]
		context: self requestContext ]
			on: self unhandledExceptionClass
			do: [ :exception | "success" ^ self ].
	
	self assert: false! !

!WAExceptionHandlerTest methodsFor: 'accessing' stamp: 'jf 12/30/2008 20:09'!
unhandledExceptionClass
	"An exception that is not handled by #handlerClass"
	^ Exception! !

TestCase subclass: #WAFileTest
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAFileTest methodsFor: 'running' stamp: 'pmm 7/24/2007 22:05'!
setUp
	file := WAFile new! !

!WAFileTest methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
testBorderline
	file fileName: 'C'.
	self assert: file fileName = 'C'.
	file fileName: 'C:'.
	self assert: file fileName = 'C:'.
	file fileName: 'C:\'.
	self assert: file fileName = ''! !

!WAFileTest methodsFor: 'testing' stamp: 'pmm 11/14/2009 22:05'!
testContents
	file contents: #(83 101 97 115 105 100 101) asByteArray.
	self assert: file rawContents = #(83 101 97 115 105 100 101) asByteArray.
	self assert: file contents = 'Seaside'.
	self assert: (file contentsDecodedUsing: 'ISO-8859-1') = 'Seaside'! !

!WAFileTest methodsFor: 'testing' stamp: 'pmm 11/14/2009 22:07'!
testContentsDecoded
	file contents: #(83 101 97 115 105 100 101) asByteArray.
	self should: [ file contentsDecoded ] raise: WAIllegalStateException.
	file contentType: 'text/plain'.
	self should: [ file contentsDecoded ] raise: WAIllegalStateException.
	file contentType: 'text/plain; charset=iso-8859-1' seasideMimeType.
	self assert: file contentsDecoded = 'Seaside'! !

!WAFileTest methodsFor: 'testing' stamp: 'lr 7/16/2009 08:52'!
testNonLatinWindowsPath
	| koreanName |
	"If the following assertion fails, your Smalltalk dialect most probably does not support non-latin characters. This is true for Squeak 3.7. If your Smalltalk dialect does support non-latin characters adjust the test."
	self shouldnt:  [
		koreanName := (String
			with: (Character codePoint: 50976)
			with: (Character codePoint: 47532)
			with: (Character codePoint: 47484)), '.txt' ]
		raise: Error.

	file fileName: koreanName.
	self assert: file fileName = koreanName.
	file fileName: 'C:\important\', koreanName.
	self assert: file fileName = koreanName! !

!WAFileTest methodsFor: 'testing' stamp: 'pmm 7/25/2007 21:39'!
testWindowsPath
	file fileName: 'C:\important\passwords.txt'.
	self assert: file fileName = 'passwords.txt'.
	file fileName: '/important/passwords.txt'.
	self assert: file fileName = '/important/passwords.txt'.
	file fileName: 'passwords.txt'.
	self assert: file fileName = 'passwords.txt'! !

TestCase subclass: #WAHeaderFieldsTest
	instanceVariableNames: 'merged one two'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAHeaderFieldsTest methodsFor: 'running' stamp: 'lr 2/22/2009 20:26'!
setUp
	merged := WAMergedHeaderFields on: (Array 
		with: (one := WAHeaderFields new) 
		with: (two := WAHeaderFields new))! !

!WAHeaderFieldsTest methodsFor: 'testing-enumerating' stamp: 'lr 2/22/2009 20:35'!
testAssociationsDo
	| keys values |
	one at: 'foo' put: 1.
	two at: 'bar' put: 2.
	keys := OrderedCollection new.
	values := OrderedCollection new.
	merged associationsDo: [ :assoc | 
		keys add: assoc key.
		values add: assoc value ].
	self assert: keys asArray = #('foo' 'bar').
	self assert: values asArray = #(1 2)! !

!WAHeaderFieldsTest methodsFor: 'testing-accessing' stamp: 'lr 2/22/2009 20:29'!
testAt
	one at: 'foo' put: 1.
	two at: 'bar' put: 2.

	self assert: (merged at: 'foo') = 1.
	self assert: (merged at: 'bar') = 2.
	self assert: (merged at: 'zork') isNil! !

!WAHeaderFieldsTest methodsFor: 'testing-accessing' stamp: 'lr 2/22/2009 20:30'!
testAtIfAbsent
	one at: 'foo' put: 1.
	two at: 'bar' put: 2.

	self assert: (merged 
		at: 'foo'
		ifAbsent: [ true ])
			= 1.
	self assert: (merged 
		at: 'bar'
		ifAbsent: [ true ])
			= 2.
	self assert: (merged
		at: 'zork'
		ifAbsent: [ true ])! !

!WAHeaderFieldsTest methodsFor: 'testing-accessing' stamp: 'lr 2/22/2009 20:31'!
testAtIfPresent
	one at: 'foo' put: 1.
	two at: 'bar' put: 2.

	self assert: (merged 
		at: 'foo' 
		ifPresent: [ :value | self assert: value = 1. true ]).
	self assert: (merged
		at: 'bar'
		ifPresent: [ :value | self assert: value = 2. true ]).
	self assert: (merged
		at: 'zork'
		ifPresent: [ :value | self fail ]) isNil! !

!WAHeaderFieldsTest methodsFor: 'testing-testing' stamp: 'lr 2/22/2009 20:36'!
testIncludesKey
	one at: 'foo' put: 1.
	two at: 'bar' put: 2.
	self assert: (merged includesKey: 'foo').
	self assert: (merged includesKey: 'bar').
	self deny: (merged includesKey: 'zork').! !

!WAHeaderFieldsTest methodsFor: 'testing-testing' stamp: 'lr 2/22/2009 20:37'!
testIsEmpty
	self assert: merged isEmpty.
	two at: 'bar' put: 2.
	self deny: merged isEmpty.
	one at: 'foo' put: 1.
	self deny: merged isEmpty! !

!WAHeaderFieldsTest methodsFor: 'testing' stamp: 'lr 2/22/2009 20:27'!
testKeyNotFound
	self assert: (one at: 'foo') isNil.
	self assert: (two at: 'foo') isNil.
	self assert: (merged at: 'foo') isNil! !

!WAHeaderFieldsTest methodsFor: 'testing-enumerating' stamp: 'lr 2/22/2009 20:33'!
testKeys
	one at: 'foo' put: 1.
	two at: 'bar' put: 2.
	self assert: merged keys asArray = #('foo' 'bar')! !

!WAHeaderFieldsTest methodsFor: 'testing-enumerating' stamp: 'lr 2/22/2009 20:35'!
testKeysAndValuesDo
	| keys values |
	one at: 'foo' put: 1.
	two at: 'bar' put: 2.
	keys := OrderedCollection new.
	values := OrderedCollection new.
	merged keysAndValuesDo: [ :key :value | 
		keys add: key.
		values add: value ].
	self assert: keys asArray = #('foo' 'bar').
	self assert: values asArray = #(1 2)! !

!WAHeaderFieldsTest methodsFor: 'testing-enumerating' stamp: 'lr 2/22/2009 20:34'!
testKeysDo
	| result |
	one at: 'foo' put: 1.
	two at: 'bar' put: 2.
	result := OrderedCollection new.
	merged keysDo: [ :each | result add: each ].
	self assert: result asArray = #('foo' 'bar')! !

!WAHeaderFieldsTest methodsFor: 'testing' stamp: 'lr 2/22/2009 20:38'!
testReadOnly
	self
		should: [ merged at: 'foo' put: 1 ]
		raise: Error.
	self
		should: [ merged at: 'foo' ifAbsentPut: [ 1 ] ]
		raise: Error.
	self
		should: [ merged removeKey: 'foo' ]
		raise: Error! !

!WAHeaderFieldsTest methodsFor: 'testing-accessing' stamp: 'lr 2/22/2009 20:31'!
testSize
	self assert: merged size = 0.
	one at: 'foo' put: 1.
	self assert: merged size = 1.
	two at: 'foo' put: 2.
	self assert: merged size = 2.
	two at: 'bar' put: 4.
	self assert: merged size = 3! !

!WAHeaderFieldsTest methodsFor: 'testing-enumerating' stamp: 'lr 2/22/2009 20:33'!
testValues
	one at: 'foo' put: 1.
	two at: 'bar' put: 2.
	self assert: merged values asArray = #(1 2)! !

!WAHeaderFieldsTest methodsFor: 'testing-enumerating' stamp: 'lr 2/22/2009 20:34'!
testValuesDo
	| result |
	one at: 'foo' put: 1.
	two at: 'bar' put: 2.
	result := OrderedCollection new.
	merged valuesDo: [ :each | result add: each ].
	self assert: result asArray = #(1 2)! !

TestCase subclass: #WAHttpVersionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAHttpVersionTest methodsFor: 'tests' stamp: 'jf 7/31/2009 10:29'!
testComparison
	"Note that the major and minor numbers MUST be treated as separate
   integers and that each MAY be incremented higher than a single digit.
   Thus, HTTP/2.4 is a lower version than HTTP/2.13, which in turn is
   lower than HTTP/12.3. Leading zeros MUST be ignored by recipients and
   MUST NOT be sent."

	| v10 v11 v24 v213 v123 |
	v10 := WAHttpVersion major: 1 minor: 0.
	v11 := WAHttpVersion major: 1 minor: 1.
	v24 := WAHttpVersion major: 2 minor: 4.
	v213 := WAHttpVersion major: 2 minor: 13.
	v123 := WAHttpVersion major: 12 minor: 3.
	
	self assert: v10 < v11.
	self assert: v10 <= v11.
	self deny: v10 > v11.
	self deny: v10 >= v11.
	self assert: v11 > v10.
	self assert: v11 >= v10.
	self deny: v11 < v10.
	self deny: v11 <= v10.
	
	self assert: v24 < v213.
	self assert: v24 <= v213.
	self deny: v24 > v213.
	self deny: v24 >= v213.
	self assert: v213 > v24.
	self assert: v213 >= v24.
	self deny: v213 < v24.
	self deny: v213 <= v24.
		
	self assert: v213 < v123.
	self assert: v213 <= v123.
	self deny: v213 > v123.
	self deny: v213 >= v123.
	self assert: v123 > v213.
	self assert: v123 >= v213.
	self deny: v123 < v213.
	self deny: v123 <= v213.
	
	self assert: v24 < v123.
	self assert: v24 <= v123.
	self deny: v24 > v123.
	self deny: v24 >= v123.
	self assert: v123 > v24.
	self assert: v123 >= v24.
	self deny: v123 < v24.
	self deny: v123 <= v24.! !

!WAHttpVersionTest methodsFor: 'tests' stamp: 'jf 7/31/2009 10:03'!
testCreation
	| version |
	version := WAHttpVersion major: 1 minor: 0.
	
	self assert: version major = 1.
	self assert: version minor = 0! !

!WAHttpVersionTest methodsFor: 'tests' stamp: 'jf 7/31/2009 10:04'!
testCreation10
	| version |
	version := WAHttpVersion http10.
	
	self assert: version major = 1.
	self assert: version minor = 0! !

!WAHttpVersionTest methodsFor: 'tests' stamp: 'jf 7/31/2009 10:04'!
testCreation11
	| version |
	version := WAHttpVersion http11.
	
	self assert: version major = 1.
	self assert: version minor = 1! !

!WAHttpVersionTest methodsFor: 'tests' stamp: 'jf 7/31/2009 10:04'!
testCreationWithNew
	| version |
	version := WAHttpVersion new.
	
	self assert: version major = 1.
	self assert: version minor = 1! !

!WAHttpVersionTest methodsFor: 'tests' stamp: 'jf 7/31/2009 10:27'!
testEquality
	| a10 b10 a11 |
	a10 := WAHttpVersion major: 1 minor: 0.
	b10 := WAHttpVersion major: 1 minor: 0.
	a11 := WAHttpVersion major: 1 minor: 1.
	
	self assert: a10 = b10.
	self assert: a10 <= b10.
	self assert: a10 >= b10.
	self deny: a10 = a11.! !

!WAHttpVersionTest methodsFor: 'tests' stamp: 'jf 9/30/2009 01:10'!
testSeasideString
	| version |
	version := WAHttpVersion 
		major: 1
		minor: 0.
	self assert: version greaseString = 'HTTP/1.0'! !

!WAHttpVersionTest methodsFor: 'tests' stamp: 'jf 9/2/2009 00:54'!
testStreamHeaderLineParsing
	| stream version |
	stream := '  GET   /foo  HTTP/1.1 ' readStream.
	stream next: 12. 
	version := WAHttpVersion readFrom: stream.
	
	self assert: version major = 1.
	self assert: version minor = 1! !

!WAHttpVersionTest methodsFor: 'tests' stamp: 'jf 7/31/2009 12:30'!
testStreamVersionNumberParsing
	| stream version |
	stream := '12.3' readStream.
	version := WAHttpVersion readFrom: stream.
	
	self assert: version major = 12.
	self assert: version minor = 3! !

!WAHttpVersionTest methodsFor: 'tests' stamp: 'jf 7/31/2009 12:29'!
testStreamVersionStringParsing
	| stream version |
	stream := 'HTTP/1.0' readStream.
	version := WAHttpVersion readFrom: stream.
	
	self assert: version major = 1.
	self assert: version minor = 0! !

!WAHttpVersionTest methodsFor: 'tests' stamp: 'jf 7/31/2009 12:31'!
testStringVersionNumberParsing
	| version string |
	string := '12.3'.
	version := WAHttpVersion fromString: string.
	
	self assert: version major = 12.
	self assert: version minor = 3! !

!WAHttpVersionTest methodsFor: 'tests' stamp: 'jf 7/31/2009 12:33'!
testStringVersionStringParsing
	| version string |
	string := 'HTTP/1.0'.
	version := WAHttpVersion fromString: string.
	
	self assert: version major = 1.
	self assert: version minor = 0! !

!WAHttpVersionTest methodsFor: 'tests' stamp: 'jf 7/31/2009 10:54'!
testTestingMethods
	| v10 v11 |
	v10 := WAHttpVersion major: 1 minor: 0.
	v11 := WAHttpVersion major: 1 minor: 1.
	
	self assert: v10 isHttp10.
	self deny: v11 isHttp10.
	self assert: v11 isHttp11.
	self deny: v10 isHttp11.! !

TestCase subclass: #WAKeyGeneratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAKeyGeneratorTest methodsFor: 'accessing' stamp: 'lr 1/17/2008 14:36'!
count
	^ 512! !

!WAKeyGeneratorTest methodsFor: 'testing' stamp: 'lr 1/10/2009 15:41'!
testStartUp
	| collection |
	WAKeyGenerator  startUp.
	collection := Set new: self count.
	self count timesRepeat: [ collection add: (WAKeyGenerator current keyOfLength: 48) ].
	
	WAKeyGenerator startUp.
	self count timesRepeat: [
		self
			deny: (collection includes: (WAKeyGenerator current keyOfLength: 48))
			description: 'This is extremely unlikely to fail, if it does repeatedly then there is something wrong with the initialization of the random-generator.' ]! !

!WAKeyGeneratorTest methodsFor: 'testing' stamp: 'lr 1/10/2009 15:41'!
testUnique
	| collection id |
	collection := Set new: self count.
	self count timesRepeat: [
		id := WAKeyGenerator current keyOfLength: 48.
		self
			deny: (collection includes: id)
			description: 'This is extremely unlikely to fail, if it does repeatedly then there is something wrong with the random generator.'.
		collection add: id ]! !

TestCase subclass: #WALocaleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WALocaleTest methodsFor: 'testing' stamp: 'pmm 3/16/2008 12:38'!
testCountryName
	| locale |
	locale := WALocale fromString: 'de-CH'.
	
	self assert: locale countryName = 'SWITZERLAND'.
	
	locale := WALocale fromString: 'en-ZA'.
	
	self assert: locale countryName = 'SOUTH AFRICA'.
	
	locale := WALocale fromString: 'eng-ZAF'.
	
	self assert: locale countryName = 'SOUTH AFRICA'! !

!WALocaleTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testIso3
	| locale |
	locale := WALocale fromString: 'gsw-CHE'.
	self assert: locale language = 'gsw'.
	self assert: locale country = 'CHE'.
	self assert: locale greaseString = 'gsw-CHE'.
	locale := WALocale fromString: 'gsw_CHE'.
	self assert: locale language = 'gsw'.
	self assert: locale country = 'CHE'.
	self assert: locale greaseString = 'gsw-CHE'! !

!WALocaleTest methodsFor: 'testing' stamp: 'pmm 3/16/2008 12:58'!
testLanguageName
	| locale |
	locale := WALocale fromString: 'de'.
	
	self assert: locale languageName = 'German'.
	
	locale := WALocale fromString: 'gsw'.
	
	self assert: locale languageName = 'Swiss German; Alemannic; Alsatian'! !

!WALocaleTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testLangugeAndCountry
	| locale |
	locale := WALocale fromString: 'de-CH'.
	self assert: locale language = 'de'.
	self assert: locale country = 'CH'.
	self assert: locale greaseString = 'de-CH'.
	locale := WALocale fromString: 'de_CH'.
	self assert: locale language = 'de'.
	self assert: locale country = 'CH'.
	self assert: locale greaseString = 'de-CH'! !

!WALocaleTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testLangugeOnly
	| locale |
	locale := WALocale fromString: 'de'.
	self assert: locale language = 'de'.
	self assert: locale country isNil.
	self assert: locale greaseString = 'de'! !

TestCase subclass: #WAMimeDocumentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAMimeDocumentTest methodsFor: 'testing' stamp: 'lr 10/18/2008 16:45'!
testAsMIMEDocumentByteArray
	| document content |
	document := #(1 2 3 4) asByteArray seasideMimeDocument.
	self assert: document contentType = WAMimeType applicationOctetStream.
	content := document content.
	self assert: content size = 4.
	self assert: content class = ByteArray.
	1 to: 4 do: [ :index | self assert: (content at: index) = index ]! !

!WAMimeDocumentTest methodsFor: 'testing' stamp: 'lr 10/18/2008 16:46'!
testAsMIMEDocumentByteArrayColon
	| document content |
	document := #(1 2 3 4) asByteArray seasideMimeDocument.
	document mimeType: WAMimeType imageJpeg.
	self assert: document contentType = WAMimeType imageJpeg.
	content := document content.
	self assert: content size = 4.
	self assert: content class = ByteArray.
	1 to: 4 do: [ :index | self assert: (content at: index) = index ]! !

!WAMimeDocumentTest methodsFor: 'testing' stamp: 'lr 10/18/2008 16:46'!
testAsMIMEDocumentString
	| document |
	document := 'hello Seaside' seasideMimeDocument.
	self assert: document contentType = WAMimeType textPlain.
	self assert: document content = 'hello Seaside'! !

!WAMimeDocumentTest methodsFor: 'testing' stamp: 'lr 10/18/2008 16:46'!
testAsMIMEDocumentStringColon
	| document |
	document := 'hello Seaside' seasideMimeDocument.
	document mimeType: 'text/x-weirdo' seasideMimeType.
	self assert: document contentType = 'text/x-weirdo' seasideMimeType.
	self assert: document content = 'hello Seaside'! !

TestCase subclass: #WAMimeTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAMimeTypeTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testBasic
	| mimeType |
	mimeType := WAMimeType fromString: 'image/jpeg'.
	self assert: mimeType main = 'image'.
	self assert: mimeType sub = 'jpeg'.
	self assert: mimeType parameters isEmpty.
	self assert: mimeType greaseString = 'image/jpeg'! !

!WAMimeTypeTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testCharSet
	| mimeType |
	mimeType := WAMimeType fromString: 'text/html'.
	mimeType charset: 'utf-8'.
	self assert: mimeType greaseString = 'text/html;charset=utf-8'! !

!WAMimeTypeTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testConversion
	| mimeType |
	mimeType := 'image/jpeg' seasideMimeType.
	self assert: (mimeType isKindOf: WAMimeType).
	self assert: mimeType main = 'image'.
	self assert: mimeType sub = 'jpeg'.
	self assert: mimeType parameters isEmpty.
	self assert: mimeType greaseString = 'image/jpeg'.
	mimeType := mimeType seasideMimeType.
	self assert: (mimeType isKindOf: WAMimeType)! !

!WAMimeTypeTest methodsFor: 'testing' stamp: 'pmm 1/4/2008 15:12'!
testEquals
	| first second |
	first := WAMimeType fromString: 'text/html'.
	second := WAMimeType fromString: 'text/html'.
	
	self assert: first = second.
	self assert: first hash = second hash.
	
	second charset: 'utf-8'.
	self assert: first = second.
	self assert: first hash = second hash.
	
	first charset: 'iso-8859-1'.
	self assert: first = second.
	self assert: first hash = second hash.
	
	second := WAMimeType fromString: 'text/xml'.
	self deny: first = second.! !

!WAMimeTypeTest methodsFor: 'testing' stamp: 'pmm 11/20/2007 11:22'!
testIsBinary
	| notBinary binary |
	notBinary := #('text/plain' 'text/bar' 'application/x-javascript' 'application/xhml+xml' 'application/xml').
	notBinary do: [ :each |
		| mimeType |
		mimeType := WAMimeType fromString: each.
		self deny: mimeType isBinary ].
	
	binary := #('application/octet-stream' 'image/jpeg').
	binary do: [ :each |
		| mimeType |
		mimeType := WAMimeType fromString: each.
		self assert: mimeType isBinary ].! !

!WAMimeTypeTest methodsFor: 'testing' stamp: 'pmm 1/4/2008 14:39'!
testIsNonStandard
	| mimeType |
	mimeType := WAMimeType fromString: 'image/png'.
	self deny: mimeType isNonStandard.
	
	mimeType := WAMimeType fromString: 'image/x-icon'.
	self assert: mimeType isNonStandard.
	
	mimeType := WAMimeType fromString: 'image/X-icon'.
	self assert: mimeType isNonStandard.
	
	mimeType := WAMimeType fromString: 'x-icon/image'.
	self assert: mimeType isNonStandard.
	
	mimeType := WAMimeType fromString: 'X-icon/image'.
	self assert: mimeType isNonStandard.! !

!WAMimeTypeTest methodsFor: 'testing' stamp: 'pmm 1/4/2008 14:37'!
testIsVendorSpecifc
	| mimeType |
	mimeType := WAMimeType fromString: 'image/png'.
	self deny: mimeType isVendorSpecific.
	
	mimeType := WAMimeType fromString: 'image/vnd.microsoft.icon'.
	self assert: mimeType isVendorSpecific.
	
	mimeType := WAMimeType fromString: 'vnd.microsoft.icon/image'.
	self deny: mimeType isVendorSpecific.! !

!WAMimeTypeTest methodsFor: 'testing' stamp: 'pmm 1/4/2008 14:32'!
testMatches
	| pattern mimeType |
	pattern := WAMimeType fromString: 'image/png'.
	mimeType := WAMimeType fromString: 'image/png'.
	self assert: (mimeType matches: pattern).
	
	mimeType := WAMimeType fromString: 'image/gif'.
	self deny: (mimeType matches: pattern).
	
	pattern := WAMimeType fromString: 'image/*'.
	mimeType := WAMimeType fromString: 'image/png'.
	self assert: (mimeType matches: pattern).
	
	mimeType := WAMimeType fromString: 'text/html'.
	self deny: (mimeType matches: pattern).
	
	pattern := WAMimeType fromString: '*/*'.
	mimeType := WAMimeType fromString: 'image/png'.
	self assert: (mimeType matches: pattern).! !

!WAMimeTypeTest methodsFor: 'testing' stamp: 'pmm 11/14/2009 22:10'!
testNoCharSet
	| mimeType |
	mimeType := WAMimeType fromString: 'text/html'.
	self assert: mimeType charSet isNil! !

!WAMimeTypeTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testParamters
	^ #('text/html;charset=utf-8' 'text/html; charset=utf-8' ) do: 
		[ :each | 
		| mimeType |
		mimeType := WAMimeType fromString: each.
		self assert: mimeType main = 'text'.
		self assert: mimeType sub = 'html'.
		self assert: mimeType parameters size = 1.
		self assert: (mimeType parameters at: 'charset') = 'utf-8'.
		self assert: mimeType greaseString = 'text/html;charset=utf-8' ]! !

TestCase subclass: #WAMutexTest
	instanceVariableNames: 'mutex process process2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAMutexTest methodsFor: 'running' stamp: 'jf 2/5/2009 10:59'!
setUp
	super setUp.
	mutex := WAMutex new! !

!WAMutexTest methodsFor: 'running' stamp: 'jf 9/30/2009 00:19'!
tearDown
	super tearDown.
	process isNil ifFalse: [ GRPlatform current terminateProcess: process ].
	process2 isNil ifFalse: [ GRPlatform current terminateProcess: process2 ].
	"Clear instance variables so that GemStone does not attempt to persist a Semaphore"
	mutex := nil.
	process := nil.
	process2 := nil! !

!WAMutexTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:19'!
testCopy
	| semaphore1 semaphore2 copy |
	semaphore1 := GRPlatform current semaphoreClass new.
	semaphore2 := GRPlatform current semaphoreClass new.
	process := [ mutex critical: 
		[ semaphore1 signal.
		semaphore2 wait ] ] newProcess.
	process resume.
	semaphore1 wait.
	copy := mutex copy.
	self deny: copy == mutex.
	self assert: copy species = mutex species.
	self assert: copy owner isNil.
	self assert: (copy critical: [ 1 ]) = 1! !

!WAMutexTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:19'!
testExclusion
	| value semaphore1 semaphore2 semaphore3 semaphore4 |
	semaphore1 := GRPlatform current semaphoreClass new.
	semaphore2 := GRPlatform current semaphoreClass new.
	semaphore3 := GRPlatform current semaphoreClass new.
	semaphore4 := GRPlatform current semaphoreClass new.
	process := 
	[ mutex critical: 
		[ semaphore1 signal.
		semaphore2 wait.
		value := 1 ] ] newProcess.
	process2 := 
	[ semaphore3 signal.
	mutex critical: 
		[ semaphore3 signal.
		semaphore4 wait.
		value := 2.
		semaphore3 signal ] ] newProcess.
	process resume.
	semaphore1 wait.
	process2 resume.
	semaphore3 wait.
	self assert: mutex owner == process.
	self assert: value isNil.
	semaphore2 signal.
	semaphore3 wait.
	self assert: mutex owner == process2.
	self assert: value = 1.
	semaphore4 signal.
	semaphore3 wait.
	self assert: mutex owner isNil.
	self assert: value = 2! !

!WAMutexTest methodsFor: 'testing' stamp: 'jf 2/5/2009 11:17'!
testMultipleEntry
	| value |
	value := mutex critical: [ mutex critical: [ 1 ] ].
	
	self assert: value = 1.
	self assert: mutex owner isNil! !

!WAMutexTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:19'!
testSelfTerminate
	| value semaphore |
	semaphore := GRPlatform current semaphoreClass new.
	process := 
	[ value := mutex critical: 
		[ semaphore signal.
		mutex terminateOwner.
		1 ] ] newProcess.
	process resume.
	semaphore wait.
	self assert: mutex owner isNil.
	self assert: value isNil.
	self assert: (GRPlatform current isProcessTerminated: process)! !

!WAMutexTest methodsFor: 'testing' stamp: 'jf 2/5/2009 11:17'!
testSimple
	| value |
	value := mutex critical: [ 1 ].
	
	self assert: value = 1.
	self assert: mutex owner isNil! !

!WAMutexTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:19'!
testTerminate
	| value semaphore1 semaphore2 semaphore3 |
	semaphore1 := GRPlatform current semaphoreClass new.
	semaphore2 := GRPlatform current semaphoreClass new.
	semaphore3 := GRPlatform current semaphoreClass new.
	process := 
	[ value := [ mutex critical: 
		[ semaphore1 signal.
		semaphore2 wait.
		1 ] ] ensure: [ semaphore3 signal ] ] newProcess.
	process resume.
	semaphore1 wait.
	self assert: mutex owner == process.
	mutex terminateOwner.
	semaphore3 wait.
	self assert: mutex owner isNil.
	self assert: value isNil.
	self assert: (GRPlatform current isProcessTerminated: process)! !

TestCase subclass: #WAObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAObjectTest methodsFor: 'testing' stamp: 'lr 4/22/2009 08:45'!
testError
	"Make sure #error: signals a subclass of WAError."
	
	self should: [ WAObject new error: 'oh dear' ] raise: WAError.
	self should: [ WAObject error: 'oh dear' ] raise: WAError! !

!WAObjectTest methodsFor: 'testing' stamp: 'jf 3/13/2009 16:25'!
testRequestContext
	| context |
	self should: [ WAObject new requestContext ] raise: WARequestContextNotFound.
	
	context := WARequestContext request: nil response: nil.
	WACurrentRequestContext
		use: context
		during: [ self assert: WAObject new requestContext == context ]! !

TestCase subclass: #WAPackagingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAPackagingTest methodsFor: 'tests' stamp: 'dkh 11/30/2009 16:33'!
testPackagingValidity
	"if this test fails, it is because the current version of the Metacello configuration for Seaside3.0 doesn't match the current GRPackage specifications"
	
	Smalltalk at: #ConfigurationOfSeaside30 ifPresent: [:cl | | gr me exceptions grease |
		gr := Dictionary new.
		GRPackage packages do: [:pkg | 
			gr at: pkg name put: pkg ].
		me := Dictionary new.
		cl project currentVersion packages do: [:pkg | 
			me at: pkg name put: pkg ].

		"the following only apply when the system if fully loaded"
		false 
			ifTrue: [ 
				exceptions := #('Sport-2' 'DynamicBindings' 'Swazoo-2' 'KomHttpServer' 'KomServices' ).
				me keys do: [:key | gr at: key ifAbsent: [ self assert: (exceptions includes: key) ]].
				exceptions := #('Grease-Core' 'Grease-Tests-Core' 'Grease-Pharo-Core' 'Grease-Tests-Pharo-Core').
				gr keys do: [:key | me at: key ifAbsent: [ self assert: (exceptions includes: key) ]]].

		exceptions := #('Seaside-FileSystem' 'Seaside-Swazoo' 'Seaside-Adaptors-Comanche' 'Seaside-Tools-OmniBrowser').
		grease := #('Seaside-Tests-Core' 'Seaside-Tests-Pharo-Continuation' 'Seaside-Core' 'Seaside-Pharo-Core' 'Seaside-Pharo-Flow' 'Seaside-Pharo-Continuation' 'Seaside-Slime' 'Seaside-GemStone-Flow' 'Seaside-GemStone-Continuation' 'Seaside-Tests-GemStone-Continuation' ).
		me values do: [:pkg | | grPkg |
			grPkg := gr at: pkg name ifAbsent: [].
			grPkg ~~ nil
				ifTrue: [ | requires dependencies |
					requires := pkg requires.
					dependencies := grPkg dependencies.
					requires size ~= dependencies size 
						ifTrue: [ self assert: (exceptions includes: pkg name) ]
						ifFalse: [
							dependencies do: [:grp |
								(requires includes: grp name) 
									ifFalse: [ 
										(grease includes: pkg name)
											ifTrue: [ self assert: (grp name beginsWith: 'Grease') ]
											ifFalse: [ self assert: false ]]]]]]].! !

TestCase subclass: #WAPathConsumerTest
	instanceVariableNames: 'consumer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAPathConsumerTest methodsFor: 'running' stamp: 'pmm 8/31/2009 10:43'!
setUp
	super setUp.
	consumer := WAPathConsumer path: #('tweets' 'kentbeck') asOrderedCollection! !

!WAPathConsumerTest methodsFor: 'testing' stamp: 'pmm 8/31/2009 10:43'!
testAtEnd
	self deny: consumer atEnd.
	consumer next.
	self deny: consumer atEnd.
	consumer next.
	self assert: consumer atEnd! !

!WAPathConsumerTest methodsFor: 'testing' stamp: 'pmm 8/31/2009 10:45'!
testNext
	self assert: consumer next = 'tweets'.
	self assert: consumer next = 'kentbeck'.
	self should: [ consumer next ] raise: Error! !

!WAPathConsumerTest methodsFor: 'testing' stamp: 'jf 9/1/2009 10:55'!
testNextIfPresent
	| evaluated |
	evaluated := false.
	consumer nextIfPresentDo: [ :next |
		 self assert: next = 'tweets'.
		evaluated := true ].
	self assert: evaluated.
	
	evaluated := false.
	consumer nextIfPresentDo: [ :next |
		 self assert: next = 'kentbeck'.
		evaluated := true ].
	self assert: evaluated.
	
	evaluated := false.
	consumer nextIfPresentDo: [ :next |
		evaluated := true ].
	self deny: evaluated! !

!WAPathConsumerTest methodsFor: 'testing' stamp: 'pmm 8/31/2009 10:46'!
testPeek
	self assert: consumer peek = 'tweets'.
	self assert: consumer peek = 'tweets'.
	consumer next.
	self assert: consumer peek = 'kentbeck'.
	self assert: consumer peek = 'kentbeck'.
	consumer next.
	self should: [ consumer peek ] raise: Error! !

!WAPathConsumerTest methodsFor: 'testing' stamp: 'jf 9/29/2009 23:15'!
testTry
	self deny: (consumer try: 'foo').
	self assert: (consumer try: 'tweets').
	self deny: (consumer try: 'tweets').
	self assert: (consumer try: 'kentbeck').
	self assert: consumer atEnd.
	self deny: (consumer try: 'kentbeck')! !

TestCase subclass: #WARegistryKeyHandlingTest
	instanceVariableNames: 'registry registrySize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 3/14/2009 00:59'!
assertCookieAddition: aResponse
	| cookie |
	self assert: aResponse cookies size = 1.
	cookie := aResponse cookies first.
	self assert: cookie path = self path.
	self assert: cookie key = self cookieKey.
	self assert: cookie discard! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 1/30/2009 14:46'!
assertCookieAddition: aResponse key: aString
	self assertCookieAddition: aResponse.
	self assert: aResponse cookies first value = aString.! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 3/14/2009 00:59'!
assertCookieDeletion: aResponse
	| cookie |
	self assert: aResponse cookies size = 1.
	cookie := aResponse cookies first.
	self assert: cookie path = self path.
	self assert: cookie key = self cookieKey.
	self assert: cookie expiry < (DateAndTime now - (Duration days: 1 hours: 0 minutes: 0 seconds: 0)).
	self deny: cookie discard! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 1/30/2009 16:04'!
assertDefault: aResponse
	self assert: registry cache size = registrySize.
	self assert: aResponse status = 404! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 1/30/2009 16:08'!
assertDispatched: aResponse
	self assert: registry cache size = registrySize.
	self assert: aResponse status = 200! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 1/30/2009 16:08'!
assertExpired: aResponse
	self assert: registry cache size = registrySize.
	self assert: aResponse status = 302.
	self assert: (aResponse headers at: 'Location') = self path! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 1/30/2009 14:31'!
assertNoCookies: aResponse
	self assert: aResponse cookies size = 0.! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 1/28/2009 20:56'!
cookieKey
	^ self fieldName! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'pmm 9/5/2009 12:24'!
createRegistry
	^ WADispatcher new
		register: WARegistry new
		at: self registryName! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jgf 1/30/2009 11:38'!
createRegistryWithCookiesEnabled
	"We have an instance variable named 'registry' and GemStone does not like 
		method temps to have the same name as instance variables."
	| newRegistry |
	newRegistry := self createRegistry.
	newRegistry configuration at: #useCookies put: true.
	^ newRegistry! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 7/31/2009 12:42'!
createRequestContextWithFieldKey: fieldString cookieKey: cookieString
	| fields cookies request |
	fields := Dictionary new.
	fieldString isNil ifFalse: [ fields at: self fieldName put: fieldString ].
	cookies := OrderedCollection new.
	cookieString isNil ifFalse: [ cookies add: ((WARequestCookie key: self cookieKey value: cookieString ) path: self path; yourself) ].
	request := (WARequest method: 'GET' uri: self path)
		setFields: fields;
		setCookies: cookies;
		yourself.
	^ WARequestContext request: request response: WABufferedResponse new! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 1/30/2009 16:04'!
dispatch: aRequestContext to: aRegistry
	registrySize := aRegistry cache size.
	[ aRegistry handle: aRequestContext ]
		on: WAResponseNotification
		do: [ :n | ].
		
	^ aRequestContext response! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 1/28/2009 20:44'!
fieldName
	^ '_key'! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 1/28/2009 21:27'!
path
	^ '/', self registryName! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 1/30/2009 16:05'!
registerNewHandler
	^ registry register: WATestNoopRequestHandler new! !

!WARegistryKeyHandlingTest methodsFor: 'private' stamp: 'jf 1/28/2009 21:28'!
registryName
	^ 'test'! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:10'!
testCookiesDisabledFieldNoCookieHandlerAbsent
	"Cookies are DISABLED.
	There is a key in the URL, no cookie, but handler specified by key does not exist"
	
	| response context |
	registry := self createRegistry.
	context := self createRequestContextWithFieldKey: '123' cookieKey: nil.
	response := self dispatch: context to: registry.
	
	"Behaviour should be the same as #testFieldNoCookieHandlerAbsent"
	self assertNoCookies: response.
	self assertExpired: response.! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:10'!
testCookiesDisabledFieldNoCookieHandlerPresent
	"Cookies are DISABLED.
	There is a key in the URL but no cookie. The handler specified by key exists."
	
	| response context key |
	registry := self createRegistry.
	key := self registerNewHandler.
	context := self createRequestContextWithFieldKey: key cookieKey: nil.
	response := self dispatch: context to: registry.
	
	self assertNoCookies: response.
	self assertDispatched: response.! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:10'!
testCookiesDisabledMatchingHandlerAbsent
	"Cookies are DISABLED.
	There is a key in the URL and a cookie and the values match. However, the handler specified by key does not exist."
	
	| response context |
	registry := self createRegistry.
	context := self createRequestContextWithFieldKey: '123' cookieKey: '123'.
	response := self dispatch: context to: registry.
	
	"Behaviour should be the same as #testFieldNoCookieHandlerAbsent."
	self assertNoCookies: response.
	self assertExpired: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:10'!
testCookiesDisabledMatchingHandlerPresent
	"Cookies are DISABLED.
	There is a key in the URL and a cookie and the values match. The handler specified by key exists."
	
	| response context key |
	registry := self createRegistry.
	key := self registerNewHandler.
	context := self createRequestContextWithFieldKey: key cookieKey: key.
	response := self dispatch: context to: registry.
	
	"Behaviour should be the same as #testFieldNoCookieHandlerPresent."
	self assertNoCookies: response.
	self assertDispatched: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:10'!
testCookiesDisabledMismatchingWithBothHandlers
	"Cookies are DISABLED.
	There is a key in the URL and a cookie but values do not match.
	Both keys have registered handlers associated with them."
	
	| response context urlKey cookieKey |
	registry := self createRegistry.
	urlKey := self registerNewHandler.
	cookieKey := self registerNewHandler.
	context := self createRequestContextWithFieldKey: urlKey cookieKey: cookieKey.
	response := self dispatch: context to: registry.
	
	"Behaviour should be the same as #testCookiesDisabledFieldNoCookieHandlerPresent."
	self assertNoCookies: response.
	self assertDispatched: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:10'!
testCookiesDisabledMismatchingWithCookieHandler
	"Cookies are DISABLED.
	There is a key in the URL and a cookie but values do not match.
	There is no handler registered at the URL key but there is one at the cookie key."
	
	| response context key |
	registry := self createRegistry.
	key := self registerNewHandler.
	context := self createRequestContextWithFieldKey: '123' cookieKey: key.
	response := self dispatch: context to: registry.
	
	"Behaviour should be the same as #testCookiesDisabledFieldNoCookieHandlerAbsent."
	self assertNoCookies: response.
	self assertExpired: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:10'!
testCookiesDisabledMismatchingWithNoHandlers
	"Cookies are DISABLED.
	There is a key in the URL and a cookie but values do not match.
	There is no handler registered at either key."
	
	| response context |
	registry := self createRegistry.
	context := self createRequestContextWithFieldKey: '123' cookieKey: '456'.
	response := self dispatch: context to: registry.
	
	"Behaviour should be the same as #testCookiesDisabledFieldNoCookieHandlerAbsent."
	self assertNoCookies: response.
	self assertExpired: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:10'!
testCookiesDisabledMismatchingWithUrlHandler
	"Cookies are DISABLED.
	There is a key in the URL and a cookie but values do not match.
	There is a handler registered at the URL key but not at the cookie key."
	
	| response context key |
	registry := self createRegistry.
	key := self registerNewHandler.
	context := self createRequestContextWithFieldKey: key cookieKey: '123'.
	response := self dispatch: context to: registry.
	
	"Behaviour should be the same as #testCookiesDisabledFieldNoCookieHandlerPresent."
	self assertNoCookies: response.
	self assertDispatched: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:11'!
testCookiesDisabledNoFieldCookieHandlerAbsent
	"Cookies are DISABLED.
	There is no key in the URL but there is a cookie. However, the handler specified by key does not exist."
	
	| response context |
	registry := self createRegistry.
	context := self createRequestContextWithFieldKey: nil cookieKey: '123'.
	response := self dispatch: context to: registry.
	
	"Behaviour should be the same as #testNoKey."
	self assertNoCookies: response.
	self assertDefault: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:11'!
testCookiesDisabledNoFieldCookieHandlerPresent
	"Cookies are DISABLED.
	There is no key in the URL but there is a cookie. The handler specified by key exists."
	
	| response context key |
	registry := self createRegistry.
	key := self registerNewHandler.
	context := self createRequestContextWithFieldKey: nil cookieKey: key.
	response := self dispatch: context to: registry.
	
	"Behaviour should be the same as #testNoKey."
	self assertNoCookies: response.
	self assertDefault: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:11'!
testCookiesDisabledNoKey
	"Cookies are DISABLED.
	There is no URL field and no cookie. This is a new request to the Registry."
	
	| response context |
	registry := self createRegistry.
	context := self createRequestContextWithFieldKey: nil cookieKey: nil.
	response := self dispatch: context to: registry.
	
	"Behaviour should be the same as #testNoKey."
	self assertNoCookies: response.
	self assertDefault: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:11'!
testFieldNoCookieHandlerAbsent
	"There is a key in the URL, no cookie, but handler specified by key does not exist"
	
	| response context |
	registry := self createRegistryWithCookiesEnabled.
	context := self createRequestContextWithFieldKey: '123' cookieKey: nil.
	response := self dispatch: context to: registry.
	
	self assertNoCookies: response.
	self assertExpired: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:15'!
testFieldNoCookieHandlerPresent
	"There is a key in the URL but no cookie. The handler specified by key exists."
	
	| response context key |
	registry := self createRegistryWithCookiesEnabled.
	key := self registerNewHandler.
	context := self createRequestContextWithFieldKey: key cookieKey: nil.
	response := self dispatch: context to: registry.
	
	self assertCookieAddition: response key: key.
	self assertDispatched: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:16'!
testMatchingHandlerAbsent
	"There is a key in the URL and a cookie and the values match. However, the handler specified by key does not exist."
	
	| response context |
	registry := self createRegistryWithCookiesEnabled.
	context := self createRequestContextWithFieldKey: '123' cookieKey: '123'.
	response := self dispatch: context to: registry.
	
	self assertCookieDeletion: response.
	self assertExpired: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:16'!
testMatchingHandlerPresent
	"There is a key in the URL and a cookie and the values match. The handler specified by key exists."
	
	| response context key |
	registry := self createRegistryWithCookiesEnabled.
	key := self registerNewHandler.
	context := self createRequestContextWithFieldKey: key cookieKey: key.
	response := self dispatch: context to: registry.
	
	self assertNoCookies: response.
	self assertDispatched: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:16'!
testMismatchingWithBothHandlers
	"There is a key in the URL and a cookie but values do not match.
	Both keys have registered handlers associated with them."
	
	| response context urlKey cookieKey |
	registry := self createRegistryWithCookiesEnabled.
	urlKey := self registerNewHandler.
	cookieKey := self registerNewHandler.
	context := self createRequestContextWithFieldKey: urlKey cookieKey: cookieKey.
	response := self dispatch: context to: registry.
	
	self assertCookieAddition: response key: urlKey.
	self assertDispatched: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:16'!
testMismatchingWithCookieHandler
	"There is a key in the URL and a cookie but values do not match.
	There is no handler registered at the URL key but there is one at the cookie key."
	
	| response context key |
	registry := self createRegistryWithCookiesEnabled.
	key := self registerNewHandler.
	context := self createRequestContextWithFieldKey: '123' cookieKey: key.
	response := self dispatch: context to: registry.
	
	self assertCookieDeletion: response.
	self assertExpired: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:16'!
testMismatchingWithNoHandlers
	"There is a key in the URL and a cookie but values do not match.
	There is no handler registered at either key."
	
	| response context |
	registry := self createRegistryWithCookiesEnabled.
	context := self createRequestContextWithFieldKey: '123' cookieKey: '456'.
	response := self dispatch: context to: registry.
	
	self assertCookieDeletion: response.
	self assertExpired: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:16'!
testMismatchingWithUrlHandler
	"There is a key in the URL and a cookie but values do not match.
	There is a handler registered at the URL key but not at the cookie key."
	
	| response context key |
	registry := self createRegistryWithCookiesEnabled.
	key := self registerNewHandler.
	context := self createRequestContextWithFieldKey: key cookieKey: '123'.
	response := self dispatch: context to: registry.
	
	self assertCookieAddition: response key: key.
	self assertDispatched: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:16'!
testNoFieldCookieHandlerAbsent
	"There is no key in the URL but there is a cookie. However, the handler specified by key does not exist."
	
	| response context |
	registry := self createRegistryWithCookiesEnabled.
	context := self createRequestContextWithFieldKey: nil cookieKey: '123'.
	response := self dispatch: context to: registry.
	
	self assertCookieDeletion: response.
	self assertExpired: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:17'!
testNoFieldCookieHandlerPresent
	"There is no key in the URL but there is a cookie. The handler specified by key exists."
	
	| response context key |
	registry := self createRegistryWithCookiesEnabled.
	key := self registerNewHandler.
	context := self createRequestContextWithFieldKey: nil cookieKey: key.
	response := self dispatch: context to: registry.
	
	self assertNoCookies: response.
	self assertDispatched: response! !

!WARegistryKeyHandlingTest methodsFor: 'testing' stamp: 'jf 1/30/2009 16:12'!
testNoKey
	"There is no URL field and no cookie. This is a new request to the Registry."
	
	| response context |
	registry := self createRegistryWithCookiesEnabled.
	context := self createRequestContextWithFieldKey: nil cookieKey: nil.
	response := self dispatch: context to: registry.
	
	self assertNoCookies: response.
	self assertDefault: response! !

TestCase subclass: #WARenderContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WARenderContextTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testAbsoluteUrlForResource
	| context |
	context := WARenderContext new.
	context resourceUrl: (WAUrl absolute: 'http://seaside.st/foo').
	self assert: (context absoluteUrlForResource: nil) isNil.
	self assert: ((context absoluteUrlForResource: 'bar') isKindOf: WAUrl).
	self assert: (context absoluteUrlForResource: 'bar') greaseString = 'http://seaside.st/foo/bar'.
	self assert: ((context absoluteUrlForResource: '/bar') isKindOf: WAUrl).
	self assert: (context absoluteUrlForResource: '/bar') greaseString = 'http://seaside.st/foo/bar'.
	self assert: ((context absoluteUrlForResource: '') isKindOf: WAUrl).
	self assert: (context absoluteUrlForResource: '') greaseString = 'http://seaside.st/foo'.
	self assert: ((context absoluteUrlForResource: 'http://localhost/foo') isKindOf: WAUrl).
	self assert: (context absoluteUrlForResource: 'http://localhost/foo') greaseString = 'http://localhost/foo'! !

!WARenderContextTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:10'!
testAbsoluteUrlForResourceWithoutBase
	| context |
	context := WARenderContext new.
	context resourceUrl: nil.
	self assert: (context absoluteUrlForResource: nil) isNil.
	self assert: ((context absoluteUrlForResource: 'bar') isKindOf: WAUrl).
	self assert: (context absoluteUrlForResource: 'bar') greaseString = '/bar'.
	self assert: ((context absoluteUrlForResource: '/bar') isKindOf: WAUrl).
	self assert: (context absoluteUrlForResource: '/bar') greaseString = '/bar'.
	self assert: ((context absoluteUrlForResource: '') isKindOf: WAUrl).
	self assert: (context absoluteUrlForResource: '') greaseString = '/'.
	self assert: ((context absoluteUrlForResource: 'http://localhost/foo') isKindOf: WAUrl).
	self assert: (context absoluteUrlForResource: 'http://localhost/foo') greaseString = 'http://localhost/foo'! !

TestCase subclass: #WARequestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WARequestTest methodsFor: 'tests' stamp: 'jf 7/31/2009 10:31'!
test10
	| request |
	request := WARequest method: 'GET' uri: '/' version: WAHttpVersion http10.
	
	self assert: request isGet.
	self assert: request isHttp10.! !

!WARequestTest methodsFor: 'tests' stamp: 'jf 7/31/2009 10:31'!
test11
	| request |
	request := WARequest method: 'GET' uri: '/' version: WAHttpVersion http11.
	
	self assert: request isGet.
	self assert: request isHttp11.! !

TestCase subclass: #WAResponseTest
	instanceVariableNames: 'response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

WAResponseTest subclass: #WABufferedResponseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WABufferedResponseTest methodsFor: 'accessing' stamp: 'lr 2/4/2009 08:02'!
contents
	| stream |
	stream := WriteStream on: String new.
	self response writeOn: stream.
	^ stream contents! !

!WABufferedResponseTest methodsFor: 'accessing' stamp: 'lr 1/17/2009 17:32'!
response
	^ super response ifNil: [ response := WABufferedResponse new ]! !

!WABufferedResponseTest methodsFor: 'testing' stamp: 'lr 1/17/2009 17:57'!
testIsCommitted
	super testIsCommitted.
	self deny: self response isCommitted! !

!WAResponseTest class methodsFor: 'testing' stamp: 'lr 1/13/2009 08:48'!
isAbstract
	^ self name = #WAResponseTest! !

!WAResponseTest methodsFor: 'private' stamp: 'lr 1/21/2009 18:52'!
assertLines: anArray
	self assert: self lines = anArray! !

!WAResponseTest methodsFor: 'accessing' stamp: 'lr 1/17/2009 17:28'!
contents
	"Answer a string of the complete response as it is sent to the client."
	
	self subclassResponsibility! !

!WAResponseTest methodsFor: 'accessing' stamp: 'jf 9/30/2009 01:06'!
lines
	"Answer the response as an array of lines, to be used within the tests."
	| result stream |
	result := OrderedCollection new.
	stream := self contents readStream.
	[ stream atEnd ] whileFalse: [ result add: (stream greaseUpToAll: String crlf) ].
	^ result asArray! !

!WAResponseTest methodsFor: 'accessing' stamp: 'lr 1/17/2009 17:29'!
response
	"Answer the response under test."

	^ response! !

!WAResponseTest methodsFor: 'testing-conveniance' stamp: 'lr 4/19/2009 23:33'!
testAttachmentWithFileName
	self response attachmentWithFileName: 'foo.txt'.
	self assertLines: #('HTTP/1.1 200 OK' 'Content-Disposition: attachment; filename="foo.txt"' 'Content-Length: 0' '')! !

!WAResponseTest methodsFor: 'testing-conveniance' stamp: 'lr 1/22/2009 08:57'!
testBasicAuthentication
	self response basicAuthenticationRealm: 'seaside'.
	self assertLines: #('HTTP/1.1 401 Unauthorized' 'WWW-Authenticate: Basic realm="seaside"' 'Content-Length: 0' '')! !

!WAResponseTest methodsFor: 'testing-cache' stamp: 'lr 1/17/2009 18:00'!
testCacheFor
	self response cacheFor: (Duration days: 1 hours: 0 minutes: 0 seconds: 0).
	self assert: (self response headerAt: 'Pragma') isNil.
	self assert: (self response headerAt: 'Expires') notNil.
	self assert: (self response headerAt: 'Cache-Control') = 'max-age=86400'! !

!WAResponseTest methodsFor: 'testing-cache' stamp: 'lr 1/17/2009 18:00'!
testCacheForever
	self response cacheForever.
	self assert: (self response headerAt: 'Pragma') isNil.
	self assert: (self response headerAt: 'Expires') notNil.
	self assert: (self response headerAt: 'Cache-Control') isNil! !

!WAResponseTest methodsFor: 'testing-cache' stamp: 'lr 1/17/2009 18:00'!
testCacheForeverExpiryDate
	| expiry delta |
	expiry := self response cacheForeverExpiryDate.
	delta := expiry - DateAndTime now.
	self assert: delta days > 7.
	self assert: delta days < 356! !

!WAResponseTest methodsFor: 'testing-status' stamp: 'lr 1/17/2009 17:43'!
testCodes
	| names codes |
	names := #( authenticationFailed forbidden found gone internalError notFound notImplemented ).
	codes := #( 401 403 302 410 500 404 501 ).
	names with: codes do: [ :name :code | 
		self response perform: name.
		self assert: self response status = code.
		self assert: self response message = (self response class messageForStatus: code) ]! !

!WAResponseTest methodsFor: 'testing' stamp: 'lr 1/22/2009 08:53'!
testContentType
	self response contentType: WAMimeType textHtml.
	self assert: self response contentType = WAMimeType textHtml.
	
	self response contentType: WAMimeType imagePng.
	self assert: self response contentType = WAMimeType imagePng! !

!WAResponseTest methodsFor: 'testing-cache' stamp: 'lr 1/17/2009 18:00'!
testDefaultCache
	self deny: (self response headers includesKey: 'Pragma').
	self deny: (self response headers includesKey: 'Expires').
	self deny: (self response headers includesKey: 'Cache-Control')! !

!WAResponseTest methodsFor: 'testing-documents' stamp: 'lr 1/17/2009 17:52'!
testDocumentMimeType
	self response document: 'alert("Seaside")' mimeType: 'text/javascript'.
	self assertLines: #('HTTP/1.1 200 OK' 'Content-Type: text/javascript' 'Content-Length: 16' '' 'alert("Seaside")')! !

!WAResponseTest methodsFor: 'testing-documents' stamp: 'lr 1/17/2009 17:54'!
testDocumentMimeTypeFileName
	self response document: 'foo;bar;zork' mimeType: 'text/csv' fileName: 'table.csv'.
	self assertLines: #('HTTP/1.1 200 OK' 'Content-Disposition: attachment; filename="table.csv"' 'Content-Type: text/csv' 'Content-Length: 12' '' 'foo;bar;zork')! !

!WAResponseTest methodsFor: 'testing-cache' stamp: 'lr 1/17/2009 18:00'!
testDoNotCache
	self response doNotCache.
	self assert: (self response headerAt: 'Pragma') = 'no-cache'.
	self assert: (self response headerAt: 'Expires') notNil.
	self assert: (self response headerAt: 'Cache-Control') = 'no-cache, must-revalidate'! !

!WAResponseTest methodsFor: 'testing-cache' stamp: 'lr 1/17/2009 18:00'!
testDoNotCacheExpiryDate
	| expiry delta |
	expiry := self response doNotCacheExpiryDate.
	delta := expiry - DateAndTime now.
	self assert: delta days < -7! !

!WAResponseTest methodsFor: 'testing-headers' stamp: 'lr 1/17/2009 17:35'!
testHeadersAt
	self assert: (self response headerAt: 'foo') isNil.
	self response headerAt: 'foo' put: 'bar'.
	self assert: (self response headerAt: 'foo') = 'bar'! !

!WAResponseTest methodsFor: 'testing-headers' stamp: 'lr 1/17/2009 17:34'!
testHeadersAtAppend
	self assert: (self response headerAt: 'foo' append: 'bar') = 'bar'.
	self assert: (self response headerAt: 'foo') = 'bar'.
	self assert: (self response headerAt: 'foo' append: 'zork') = 'zork'.
	self assert: (self response headerAt: 'foo') = 'bar'.
	self assert: (self response headers size) = 2! !

!WAResponseTest methodsFor: 'testing-headers' stamp: 'lr 1/17/2009 17:36'!
testHeadersAtIfAbsent
	self assert: (self response headerAt: 'foo' ifAbsent: [ 'zork' ]) = 'zork'.
	self response headerAt: 'foo' put: 'bar'.
	self assert: (self response headerAt: 'foo' ifAbsent: [ 'zork' ]) = 'bar'! !

!WAResponseTest methodsFor: 'testing-headers' stamp: 'lr 1/17/2009 17:35'!
testHeadersAtPut
	self assert: (self response headerAt: 'foo' put: 'bar') = 'bar'.
	self assert: (self response headerAt: 'foo') = 'bar'.
	self assert: (self response headerAt: 'foo' put: 'zork') = 'zork'.
	self assert: (self response headerAt: 'foo') = 'zork'.
	self assert: (self response headers size) = 1! !

!WAResponseTest methodsFor: 'testing-headers' stamp: 'lr 1/17/2009 17:37'!
testHeadersRemoveAt
	self response headerAt: 'foo' put: 'bar'.
	self response headerAt: 'bar' put: 'baz'.
	self assert: (self response removeHeaderAt: 'foo') = 'bar'.
	self assert: (self response removeHeaderAt: 'bar') = 'baz'.
	self assert: (self response headers isEmpty)! !

!WAResponseTest methodsFor: 'testing-conveniance' stamp: 'lr 4/19/2009 23:34'!
testInlineWithFileName
	self response inlineWithFileName: 'bar.txt'.
	self assertLines: #('HTTP/1.1 200 OK' 'Content-Disposition: inline; filename="bar.txt"' 'Content-Length: 0' '')! !

!WAResponseTest methodsFor: 'testing' stamp: 'lr 1/17/2009 17:58'!
testIsCommitted
	self deny: self response isCommitted.
	self response contentType: 'text/html'.

	self deny: self response isCommitted.
	self response nextPutAll: 'Visit <a href="http://www.seaside.st">seaside.st</a>.'.

	self assertLines: #('HTTP/1.1 200 OK' 'Content-Type: text/html' 'Content-Length: 53' '' 'Visit <a href="http://www.seaside.st">seaside.st</a>.')! !

!WAResponseTest methodsFor: 'testing-status' stamp: 'lr 1/17/2009 17:42'!
testMessage
	self assert: self response message = 'OK'.
	
	self response status: 404.
	self assert: self response message = 'Not Found'.
	
	self response status: 290.
	self assert: self response message isNil.
	
	self response status: 290 message: 'Seaside Rocks'.
	self assert: self response message = 'Seaside Rocks'.! !

!WAResponseTest methodsFor: 'testing-conveniance' stamp: 'lr 1/22/2009 08:59'!
testRedirectTo
	self response redirectTo: 'http://www.seaside.st/'.
	self assertLines:  #('HTTP/1.1 302 Found' 'Location: http://www.seaside.st/' 'Content-Length: 0' '')! !

!WAResponseTest methodsFor: 'testing-conveniance' stamp: 'lr 2/15/2009 09:43'!
testRefreshAfterLocation
	self response refreshAfter: 3 seconds location: 'http://www.seaside.st/'.
	self assertLines: #('HTTP/1.1 200 OK' 'Refresh: 3; http://www.seaside.st/' 'Content-Length: 0' '')! !

!WAResponseTest methodsFor: 'testing-status' stamp: 'lr 1/17/2009 17:40'!
testStatus
	self assert: self response status = 200.
	self response status: 404.
	self assert: self response status = 404! !

!WAResponseTest methodsFor: 'testing' stamp: 'lr 1/22/2009 09:14'!
testStreaming
	| stream |
	self response notFound.
	
	" This is a normal write stream that supports the standard WriteStream protocol. All Smalltalk dialects should support common messages such as #nextPut:, #nextPutAll:, #print:, #crlf, etc."
	stream := self response stream.
	stream nextPutAll: 'A long long way from home.'.
	stream crlf.
	stream nextPut: $!!.
	stream print: 123.
	
	self assertLines: #('HTTP/1.1 404 Not Found' 'Content-Length: 32' '' 'A long long way from home.' '!!123')! !

WAResponseTest subclass: #WAStreamedResponseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAStreamedResponseTest methodsFor: 'private' stamp: 'lr 1/17/2009 17:51'!
assertLines: anArray
	"Streamed responses don't have content length information. They simply can't know."
	
	super assertLines: (anArray reject: [ :each | each beginsWith: 'Content-Length' ])! !

!WAStreamedResponseTest methodsFor: 'accessing' stamp: 'lr 1/23/2009 11:16'!
contents
	self response flush.
	^ self response stream contents! !

!WAStreamedResponseTest methodsFor: 'accessing' stamp: 'lr 2/4/2009 08:02'!
response
	^ super response ifNil: [ response := WAStreamedResponse on: (WriteStream on: String new) ]! !

!WAStreamedResponseTest methodsFor: 'testing-state' stamp: 'lr 1/22/2009 09:06'!
testCookieAfterCommit
	self response flush.
	self 
		should: [ self response addCookie: WACookie new ]
		raise: WAIllegalStateException! !

!WAStreamedResponseTest methodsFor: 'testing-flush' stamp: 'lr 1/23/2009 11:19'!
testFlushDelay
	self response forbidden.
	self response headerAt: 'X-Application-Server' put: 'Seaside'.
	self deny: self response isCommitted.
	self 
		shouldnt: [ self response committedCheck ]
		raise: WAIllegalStateException! !

!WAStreamedResponseTest methodsFor: 'testing-flush' stamp: 'lr 1/23/2009 11:19'!
testFlushNextPutAll
	self response nextPutAll: 'Hello World'. " <-- should flush "
	self assert: self response isCommitted.
	self 
		should: [ self response committedCheck ]
		raise: WAIllegalStateException.
	self assertLines: #('HTTP/1.1 200 OK' '' 'Hello World')! !

!WAStreamedResponseTest methodsFor: 'testing-flush' stamp: 'lr 1/23/2009 11:19'!
testFlushStream
	self response stream. " <-- should flush "
	self assert: self response isCommitted.
	self 
		should: [ self response committedCheck ]
		raise: WAIllegalStateException.
	self assertLines: #('HTTP/1.1 200 OK' '')! !

!WAStreamedResponseTest methodsFor: 'testing-state' stamp: 'lr 1/22/2009 09:05'!
testHeaderAfterCommit
	self response flush.
	self 
		should: [ self response headerAt: 'foo' put: 'bar' ]
		raise: WAIllegalStateException.
	self 
		should: [ self response headerAt: 'foo' append: 'bar' ]
		raise: WAIllegalStateException.
	self 
		should: [ self response removeHeaderAt: 'foo' ]
		raise: WAIllegalStateException! !

!WAStreamedResponseTest methodsFor: 'testing' stamp: 'lr 1/17/2009 17:57'!
testIsCommitted
	super testIsCommitted.
	self assert: self response isCommitted! !

!WAStreamedResponseTest methodsFor: 'testing-state' stamp: 'lr 1/22/2009 09:06'!
testStatusAfterCommit
	self response flush.
	self 
		should: [ self response forbidden ]
		raise: WAIllegalStateException.
	self 
		should: [ self response status: 404 message: 'Almost found' ]
		raise: WAIllegalStateException! !

TestCase subclass: #WAServerManagerTest
	instanceVariableNames: 'adaptor manager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAServerManagerTest methodsFor: 'private' stamp: 'yann.monclair 9/5/2009 18:06'!
availablePort
	"This method should always return an unused port for the server manager"
	^(manager adaptors collect: [ :each | 
			each port ] ) asSet max + 1! !

!WAServerManagerTest methodsFor: 'testing' stamp: 'pmm 9/6/2009 13:41'!
setUp
	super setUp.
	manager := WAServerManager new.
	adaptor := WATestServerAdaptor manager: manager.
	adaptor port: 12345.
	adaptor running.
	self assert: adaptor isRunning.
	self assert: (manager adaptors includes: adaptor).! !

!WAServerManagerTest methodsFor: 'testing' stamp: 'yann.monclair 9/5/2009 18:05'!
tearDown
	super tearDown.
	adaptor stopped.
	self assert: adaptor isStopped.
	manager unregister: adaptor.
	self deny: (manager adaptors includes: adaptor).! !

!WAServerManagerTest methodsFor: 'testing' stamp: 'yann.monclair 9/5/2009 18:07'!
testCanStartWithAvailablePort
	adaptor starting.
	self deny: ( manager canStart: adaptor ).
	adaptor running.
	self deny: ( manager canStart: adaptor ).
	adaptor stopping.
	self deny: ( manager canStart: adaptor ).
	adaptor stopped.
	self assert: ( manager canStart: adaptor ).! !

!WAServerManagerTest methodsFor: 'testing' stamp: 'jf 9/28/2009 00:38'!
testCanStartWithUnavailablePort

	| adaptor1  |
	adaptor1 := WATestServerAdaptor manager: manager.
	adaptor1 port: adaptor port.
	adaptor1 starting.
	self deny: ( manager canStart: adaptor1 ).
	adaptor1 running.
	self deny: ( manager canStart: adaptor1 ).
	adaptor1 stopping.
	self deny: ( manager canStart: adaptor1 ).
	adaptor1 stopped.
	self deny: ( manager canStart: adaptor1 ).! !

!WAServerManagerTest methodsFor: 'testing' stamp: 'yann.monclair 9/5/2009 18:07'!
testCanStop

	adaptor starting.
	self assert: ( manager canStop: adaptor ).
	adaptor running.
	self assert: ( manager canStop: adaptor ).
	adaptor stopping.
	self assert: ( manager canStop: adaptor ).
	adaptor stopped.
	self deny: ( manager canStop: adaptor )! !

WASystemConfiguration subclass: #WAConfigurationMock
	instanceVariableNames: 'describeBlock parentsBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WAConfigurationMock class methodsFor: 'instance creation' stamp: 'jf 7/22/2008 16:16'!
new
	"For testing, we'd rather create new instances than use singletons."
	^ self basicNew initialize! !

!WAConfigurationMock methodsFor: 'description' stamp: 'jf 7/29/2008 18:15'!
describeOn: config
	describeBlock isNil ifFalse: [ describeBlock value: config ]! !

!WAConfigurationMock methodsFor: 'accessing' stamp: 'jf 7/29/2008 18:12'!
description: aBlock
	describeBlock := aBlock! !

!WAConfigurationMock methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:47'!
parents
	^ parentsBlock isNil 
		ifFalse: [ parentsBlock value ]
		ifTrue: 
			[ #() ]! !

!WAConfigurationMock methodsFor: 'accessing' stamp: 'jf 7/24/2008 19:47'!
parents: aBlock 
	parentsBlock := aBlock! !

WAFileLibrary subclass: #WATestingFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WATestingFiles methodsFor: 'overrides' stamp: 'pmm 9/5/2009 14:15'!
defaultFileHandler
	"Superclass could have implementation of (WAFileHandler default), 
	but that is not defined at time test runs when they are loaded in order."

	^WADispatcher new
		register: WAFileHandler new
		at: 'files'! !

!WATestingFiles methodsFor: 'overrides' stamp: 'pmm 2/21/2009 16:03'!
nonFileSelectors
	^ super nonFileSelectors copyWith: #defaultFileHandler! !

!WATestingFiles methodsFor: 'accessing-images' stamp: 'jf 10/6/2008 17:46'!
sampleJs
	^ '
	function foo (a, b) {

}'! !

!WATestingFiles methodsFor: 'uploaded' stamp: ''!
samplePng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 214 4 9 20 4 42 36 195 187 166 0 0 2 112 73 68 65 84 56 203 173 147 221 75 83 113 24 199 63 155 155 110 57 245 164 169 232 24 180 240 173 50 207 48 74 144 68 27 82 209 141 43 147 145 136 226 159 97 36 236 70 130 174 162 232 38 34 42 86 104 26 42 5 74 47 243 5 65 212 110 52 148 48 95 74 156 107 206 236 156 249 50 117 110 167 139 58 232 130 186 144 30 248 193 247 226 249 124 248 61 207 143 31 28 172 146 107 156 213 74 119 119 183 114 16 216 180 15 222 19 184 65 116 67 167 27 228 223 167 211 13 226 31 112 226 126 184 198 89 173 104 84 24 232 183 55 54 10 73 201 41 16 217 37 184 178 66 95 107 171 4 84 44 222 110 89 150 229 96 219 204 204 76 89 93 109 61 85 85 85 212 56 171 105 111 123 169 87 5 157 246 250 122 135 226 245 18 24 25 1 69 225 136 77 132 212 52 94 127 15 140 249 46 86 230 100 103 153 15 23 228 159 160 188 188 92 133 117 64 36 14 224 42 60 40 42 41 73 88 236 233 97 119 99 131 104 56 204 178 94 199 156 205 198 194 217 211 230 230 155 46 163 86 27 135 40 138 108 132 130 60 122 248 88 7 68 0 180 234 112 74 40 4 202 222 78 190 230 230 225 63 83 76 83 83 51 62 159 143 188 188 60 218 59 94 176 24 76 222 108 56 89 89 168 246 169 2 79 48 16 32 45 63 31 157 193 192 252 229 75 248 47 216 185 238 172 197 231 243 97 52 26 233 31 232 227 211 236 23 4 177 250 208 146 144 237 138 17 76 31 79 126 254 166 191 87 193 100 226 104 105 41 19 69 133 92 113 92 99 109 109 13 69 81 88 95 15 50 60 58 202 80 192 138 201 168 195 159 146 105 143 17 124 168 73 170 141 27 44 211 188 21 38 232 26 241 144 62 61 133 167 239 61 130 32 32 203 50 119 238 221 229 227 143 12 66 187 113 108 135 35 49 239 170 3 208 155 37 123 162 152 195 192 173 49 182 36 3 130 55 132 102 106 146 150 251 207 8 71 34 172 104 173 44 109 9 164 101 89 9 200 219 100 202 126 79 140 0 32 204 38 74 244 87 150 204 195 196 235 102 241 246 26 176 228 22 99 200 182 112 42 43 129 213 245 29 62 15 116 72 54 105 201 21 35 8 123 5 207 106 116 206 97 201 201 96 97 122 25 128 236 226 45 178 114 94 49 120 99 202 247 77 41 72 4 200 148 253 30 155 180 228 122 50 249 110 92 21 104 0 28 117 86 49 122 46 208 127 190 193 34 24 73 37 202 46 235 138 159 161 167 43 146 118 40 189 162 203 61 63 254 183 143 161 81 131 163 206 42 238 28 219 113 233 205 146 93 189 85 252 92 188 235 95 240 127 169 159 24 23 11 103 188 240 115 88 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!WATestingFiles methodsFor: 'overrides' stamp: 'jgf 1/26/2009 09:32'!
urlOf: aSymbol
	"Could this be moved to the superclass? --JGF"
	
	^self 
		urlOf: aSymbol
		using: self defaultFileHandler.! !

WAServerAdaptor subclass: #WATestServerAdaptor
	instanceVariableNames: 'status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!

!WATestServerAdaptor commentStamp: 'yann.monclair 9/5/2009 17:26' prior: 0!
A WATestServerAdaptor is a stub of a server adaptor. It doesn't start an adaptor, it just pretends to allow testing of the server manager!

!WATestServerAdaptor methodsFor: 'testing' stamp: 'yann.monclair 9/5/2009 17:27'!
isRunning
	^status = #running! !

!WATestServerAdaptor methodsFor: 'testing' stamp: 'yann.monclair 9/5/2009 17:27'!
isStarting
	^status = #starting! !

!WATestServerAdaptor methodsFor: 'testing' stamp: 'yann.monclair 9/5/2009 17:27'!
isStopped
	^status = #stopped! !

!WATestServerAdaptor methodsFor: 'testing' stamp: 'yann.monclair 9/5/2009 17:27'!
isStopping
	^status = #stopping! !

!WATestServerAdaptor methodsFor: 'initialization' stamp: 'yann.monclair 9/5/2009 17:28'!
running
	status := #running! !

!WATestServerAdaptor methodsFor: 'initialization' stamp: 'yann.monclair 9/5/2009 17:28'!
starting
	status := #starting! !

!WATestServerAdaptor methodsFor: 'initialization' stamp: 'yann.monclair 9/5/2009 17:28'!
stopped
	status := #stopped! !

!WATestServerAdaptor methodsFor: 'initialization' stamp: 'yann.monclair 9/5/2009 17:28'!
stopping
	status := #stopping! !

!GRPackage class methodsFor: '*seaside-tests-core' stamp: 'jf 9/30/2009 01:19'!
seasideTestsCore
	^ self new
		name: 'Seaside-Tests-Core';
		description: 'Unit tests for the package Seaside-Core.';
		addDependency: 'Seaside-Core';
		addDependency: 'Grease-Tests-Core';
		yourself! !

GRError subclass: #WATestError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Core'!
